
/******************************************
converts dic file of davar3 to text output for mDavar2
input file: 1.dic
output files	temp files are 1.tmp and 1i.tmp,
				then are cutted to:
				from hebrew are 0001, 0002, ...
				from english/czech/etc.. are 0001i, 0002i etc..
				also, index files index (HE->CZ)and indexi(CZ->HE) are created
*/


#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


#define			FILE_LENGTH			4096		//bytes.
#define			INDEX_LENGTH		8			//length of indexed word
int				BUF_SIZE = 300;

int				f, g, h, i, j, l, r;

FILE			*fin;
FILE			*fout;
int				max;

unsigned char	label_from[40];			//
unsigned char	label_to[40];			//


int				records;			//number of records in dic
unsigned char	*data;				//pointer to dynamically allocated space to all data
int				data_off;			//offset of data
int				data_len;			//length of data

unsigned char	*index;				//pointer to dynamically allocated space for index-opposite direction!
int				index_off;			//offset of index




int				counter;			//counter of file names


unsigned char	buf[300];			//
unsigned char	buf2[300];			//

unsigned char	last_word[300];		//backup of last word from previous file
unsigned char	first_word[300];	//backup of first word from actual file

unsigned char	one_record[FILE_LENGTH];	//one record

unsigned char	raz_local[3][512];			//table of sorting for HE/EN language. Here will read TAB data+export it
FILE			*tabulka;					//TAB file
int				n1,n2,n3, n4;				//4 numbers red from TAB file.1,2=char code, 3=map flag, 4=UNICODE value

int				*pi;


int main()
{


//open input file
fin=fopen("1.dic", "rb");
if(fin==NULL){
	printf("Error openning input file 1.dic \n");
	return 0;
}


//open output file - 1.tmp
fout=fopen("1.tmp", "wb");
if(fout==NULL){
	printf("Error creating temp output file 1.tmp\n");
	return 0;
}

fseek(fin, 0, SEEK_SET	);
fseek(fout, 0, SEEK_SET	);

//both opened


//short test of dic format:
if(	fgetc(fin) != 'h' ||
	fgetc(fin) != 'b' ||
	fgetc(fin) != 'd' ||
	fgetc(fin) != 'i' 	){

	printf("Wrong type of 1.dic file!");
	return	0;
}

g=fgetc(fin);
if(g != 5){
	printf("Wrong version of dictionary file 1.dic!");
	return	0;
}

//get number of records:
fseek(fin, 22, SEEK_SET	);
fread(&records, 4, 1, fin);

//get offset of data
fseek(fin, 18, SEEK_SET	);
fread(&data_off, 4, 1, fin);

//get length of file/data
fseek(fin, 0, SEEK_END);
f = ftell(fin);
data_len = f - data_off;

//get offset of index
fseek(fin, 14, SEEK_SET	);
fread(&index_off, 4, 1, fin);


//get labels, will use only max 39 chars+0!
//get length of file/data
memset(label_from, 0, 40);
memset(label_to, 0, 40);

fseek(fin, 30, SEEK_SET);
fread(&label_from, 39, 1, fin);
fseek(fin, 94, SEEK_SET);
fread(&label_to, 39, 1, fin);



//now will read all data section to memory
//allocate double space!
data = (char*) malloc (data_len * 2);
if(data == NULL){
	printf("Cannot allocate %d bytes for data!", data_len);
	return	0;
}

memset(data, 0, (data_len * 2));

//copy all data to buffer
fseek(fin, data_off, SEEK_SET);
fread(data, data_len, 1, fin);


//now will read all INDEX section to memory
//allocate double space!
index = (char*) malloc (records * 4 * 2);		//one index is 4 bytes, alloc TWICE MORE
if(index == NULL){
	printf("Cannot allocate %d bytes for index!", (records * 4 * 2));
	return	0;
}

memset(index, 0, (records * 4 * 2));

//copy all index to buffer
fseek(fin, index_off, SEEK_SET);
fread(index, records*4, 1, fin);






//OK, now will parse all file and reconstruct records to format:
//0x01
//HE_word
//0x02
//latin_word

f = 0;
while (f < data_len){
	if(	data[f] == '|' &&
		data[f+1] == 'S' &&
		data[f+2] == '2' ){

		//ok, found start of record. Now skip 5x ',' and there will be HE word \0 and LAT word \0, will skip note
		f+=3;		//point to ','
		for(g=0; g<5; g++){
			while(data[f++] != ','){
				;
			}
			continue;
		}
		//ok

		//test print
		//		printf("offset %d %s %s\n", f, &data[f], &data[1+f+strlen(&data[f])] );

		//export it:
		fputc(1, fout);
		fprintf(fout, &data[f]);
		fputc(2, fout);
		fprintf(fout, &data[1+f+strlen(&data[f])] );
	}
	f++;
}

//WE WILL FREE DATA LATER!!! free(data);

fclose(fin);
fclose(fout);




//now open 2.tmp for opposite direction

fout=fopen("2.tmp", "wb");
if(fout==NULL){
	printf("Error creating temp output file 2.tmp\n");
	return 0;
}

fseek(fout, 0, SEEK_SET	);

for(h=0; h<records; h++){
	//get offset on data buf:
	i=*( (int*) &index[h*4] );		//offset in file

	i-=data_off;			//in data buffer

	if(!(	data[i] == '|' &&
			data[i+1] == 'S' &&
			data[i+2] == '2' ) ){

			printf("Error sync of index\n");
			return 0;
			}
			//OK, we have from i: |S2  and data, read them

			//ok, found start of record. Now skip 5x ',' and there will be HE word \0 and LAT word \0, will skip note
			i+=3;		//point to ','
			for(g=0; g<5; g++){
				while(data[i++] != ','){
					;
				}
				continue;
			}
			//ok

			memset(buf, 0, BUF_SIZE);
			memset(buf2, 0, BUF_SIZE);

			strcpy(buf, &data[i]);
			strcpy(buf2, &data[1+i+strlen(&data[i])]);

			//export it:
			fputc(1, fout);
			fprintf(fout, "%s", buf2);	//CZ
			fputc(2, fout);
			fprintf(fout, "%s", buf);	//HE

}
fclose(fout);


//------------------------------------------------------------------------

//now we will cut big file 1.tmp to many small, FILE_LENGTH long
//open input file
fin=fopen("1.tmp", "rb");
if(fin==NULL){
	printf("Error openning input file 1.tmp \n");
	return 0;
}

//get length of file
fseek(fin, 0, SEEK_END);
data_len = ftell(fin);

//now will read all data to memory
data = (char*) malloc (data_len * 2);
if(data == NULL){
	printf("Cannot allocate %d bytes for data!", data_len);
	return	0;
}

memset(data, 0, (data_len * 2));

//copy all data to buffer
fseek(fin, 0, SEEK_SET);
fread(data, data_len, 1, fin);




counter = 1;			//will start 0001

f=0;					//data pointer

while(f < data_len){

	//create filename
	sprintf(buf, "%04d", counter);

	//open input file
	fout=fopen(buf, "wb");
	if(fout==NULL){
		printf("Error openning output file %s \n", buf);
		return 0;
	}

	//copy data
	g = FILE_LENGTH;

	if ((data_len - f) < FILE_LENGTH)
		g = data_len - f;

	fwrite(&data[f], g, 1, fout);


	fclose(fout);

	f+= FILE_LENGTH;
	counter++;
}

counter--;		//counter will be used later!


fclose(fin);

if(remove("1.tmp") != 0){
	printf("Cannot remove temp file 1.tmp");
	return	0;
}




//-------------------------------------------

//Now will export sort_from (HEBREW SORTING TABLE)
//and sort_to (CZECH/ENGLISH... sorting table)
//use TAB files from Davar3 and name them: from.tab and to.tab
//Be sure, that from.tab is for HEBREW!!!

/*
Structure of sorting tables: sort (FROM, HE ) and sorti (TO, CZ(Eng)...etc)
|     0 | 768| Sorting table for FROM or TO language. Max. 128 items, unused  |
|       |    |positions filled by 0. Each item consists from:                 |
|       |    |1. byte:  unsigned char 1. character (as in Davar)              |
|       |    |2. byte:  unsigned char 2. character or 0 (as in Davar)         |
|       |    |3.-4 byte: UNICODE value 1. character, or 0.  Unsigned short    |
|       |    |5.byte:    unsigned char  mapping flag (0 or 1)                 |
|       |    |6.byte:    unsigned char  = 0 (reserved)                        |
|       |    |unused bytes filled by 0                                        |
*/

//first read both tab files to memory:


for(j=0; j<2; j++){						//will pass with 2 files


if(j==0){
	tabulka=fopen("from.tab", "rt");		//from.tab file - cteni v text rezimu!
	if(tabulka==NULL){					//nelze otevrit tabulku!
		printf("ERROR: Cannot open file from.tab \n");
		return -1;
	}

	//open output file sort
	fout=fopen("sort", "wb");
	if(fout==NULL){
		printf("Error creating FROM sorting file: sort \n");
		return -1;
	}
	fseek(fout, 0, SEEK_SET	);
}

if(j==1){
	tabulka=fopen("to.tab", "rt");			//to.tab file - cteni v text rezimu!
	if(tabulka==NULL){						//nelze otevrit tabulku!
		printf("ERROR: Cannot open file to.tab \n");
		return -1;
	}

	//open output file sorti
	fout=fopen("sorti", "wb");
	if(fout==NULL){
		printf("Error creating TO sorting file: sorti \n");
		return -1;
	}
	fseek(fout, 0, SEEK_SET	);
}


//OK, file uspesne otevren. Kazdy radek cteme tak dlouho, dokud
//neni # (poznamka) nebo \n. Pokud je buffer delsi nez 0 znaku, pak jej cteme.
//ocekavame 3 integer cisla oddelena ','. Pokud nacteme 0,0,0 jde o posledni radek!
fseek(tabulka, 0, SEEK_SET);		//na zacatek

while(1){							//POZOR: MUSI byt ukonceni 0,0,0 jinak to fakt ZATUHNE!!!
	memset(buf, 0, BUF_SIZE);	//nuluj buffer
	f=0;					//pocet nactenych znaku
	while(g=fgetc(tabulka), (g !='\n' && g != '#')){	//do konce radku nebo #
		buf[f]=(unsigned char)g;
		f++;
	}
	//pokud g!='\n', pak cti az do konce radku
	if(g!='\n'){
		while(g=fgetc(tabulka), (g !='\n') )
			;
	}
	// do buf[] pridej koncovy znak \0, JEN POKUD JE DELSI NEZ 0 NACTENYCH ZNAKU!
	//pak to zpracuj
	if(f==0)			//nebyl radek s cisly
		continue;		//dalsi pruchod

	//zpracovavame to!
	buf[++f]=0;					//dopln nulovy znak na konec
	sscanf(buf,"%d,%d,%d", &n1, &n2, &n3);		//nacteme cisla

	//1. cast tabulky neukladame, jen preskakujeme!
	//raz_local[0][2*h]=n1;		//znak1
	//raz_local[0][2*h+1]=n2;		//znak2
	//raz_local[1][2*h]=n3;		//mapa
	//h++;

	if(!(n1 | n2 | n3))			//zadano 0,0,0=>konec tabulky
		break;

}


//Preskocena prvni cast TAB
//Kazdy radek cteme tak dlouho, dokud
//neni # (poznamka) nebo \n. Pokud je buffer delsi nez 0 znaku, pak jej cteme.
//ocekavame 3 integer cisla oddelena ','. Pokud nacteme 0,0,0 jde o posledni radek!
memset(&raz_local[0][0], 0, 512);	//nuluj tabulku razeni
memset(&raz_local[1][0], 0, 512);	//nuluj tabulku map
memset(&raz_local[2][0], 0, 512);	//nuluj tabulku unicode
h=0;								//citac radku trojic cisel

while(1){							//POZOR: MUSI byt ukonceni 0,0,0 jinak to fakt ZATUHNE!!!
	memset(buf, 0, BUF_SIZE);	//nuluj buffer
	f=0;					//pocet nactenych znaku
	while(g=fgetc(tabulka), (g !='\n' && g != '#' && g!= EOF)){	//do konce radku nebo # nebo konce file
		buf[f]=(unsigned char)g;
		f++;
	}

	//pokud g!='\n', pak cti az do konce radku
	if(g!='\n'){
		while(g=fgetc(tabulka), (g !='\n' && g!= EOF) )
			;
	}

	if(g == EOF)	break;

	// do buf[] pridej koncovy znak \0, JEN POKUD JE DELSI NEZ 0 NACTENYCH ZNAKU!
	//pak to zpracuj
	if(f==0)			//nebyl radek s cisly
		continue;		//dalsi pruchod

	//zpracovavame to!
	buf[++f]=0;					//dopln nulovy znak na konec
	sscanf(buf,"%d,%d,%d,%d", &n1, &n2, &n3, &n4);		//nacteme cisla

	raz_local[0][2*h]=n1;		//znak1
	raz_local[0][2*h+1]=n2;		//znak2
	raz_local[1][2*h]=n3;		//mapa
	raz_local[1][2*h+1]=0;		//doplnime nulu
	raz_local[2][2*h]=n4 % 256;	//LOW byte UNICODE
	raz_local[2][2*h+1]=n4 / 256;//HI byte UNICODE

	h++;

	if(!(n1 | n2 | n3))			//zadano 0,0,0=>konec tabulky
		break;

	if(h>128)
		break;					//ochrana, pokud je zadano vice radku, at nepiseme do cizi pameti!

}

fclose(tabulka);				//zavreme TAB


//otestujeme, zda se NECO nacetlo-kolik radku bylo zpracovano
if(h<20){				//tabulka by mela mit alespon 26 radku-english
	printf("WARNING: Check if sorting table is correct. Less than 20 characters!!! \n");

}

//ok, now export data to mDavar format: files "sort" and "sorti"

for(f=0; f<128; f++){

	fputc(raz_local[0][2*f], fout);			//znak1
	fputc(raz_local[0][2*f+1], fout);		//znak2

	if(raz_local[0][2*f+1] == 0){			//neni sprezka
		fputc(raz_local[2][2*f], fout);		//LO BYTE UNICODE
		fputc(raz_local[2][2*f+1], fout);	//HI BYTE UNICODE
	}
	else{						//sprezka-unicode nedavame, ale dame 0, 0
		fputc(0, fout);
		fputc(0, fout);
	}

	fputc(raz_local[1][2*f], fout);			//mapa
	fputc(0, fout);							//0-reserved
}

fclose(fout);

}	//end j cycle for







//-------------------------------------------

//finally we will create index. Open each file and get first and last word
//first word is shortened to INDEX_LENGTH and flag "search in previous file too" is
//determined. (words from previous and actual file are EXACTLY same).
//file format of index and indexi:
/*
| offset|    |                                                                |
|       |    |                                                                |
|     0 |  40| Name of dictionary, unused = 0. Last char (offset 39) is 0     |
|    40 |   4| Number of all files for direction of index                     |
|    44 |   4| Number of all words                                            |
|    48 |   1| Length of keyword (INDEX_LENGTH) default value is 8            |
|    49 |    | unused bytes filled by 0                                       |

|  1024 |    |DATA AREA. Structure of data:                                   |
|       |    |INDEX_LENGTH bytes of keyword for file 0001. Unused bytes are 0 |
|       |    |1 byte flag: 0 when previous file, last record has DIFFERENT    |
|       |    |word, 1 when has EXACTLY same word                              |
|       |    |                                                                |
|       |    |INDEX_LENGTH bytes of keyword for file 0002. Unused bytes are 0 |
|       |    |1 byte flag: 0 when previous file, last record has DIFFERENT    |
|       |    |word, 1 when has EXACTLY same word                              |
|       |    |                                                                |
|       |    |...etc for all files of same direction                          |

*/

// CREATION FROM=>TO INDEX: index

//open output file - index
fout=fopen("index", "wb");
if(fout==NULL){
	printf("Error creating index file: index\n");
	return 0;
}
fseek(fout, 0, SEEK_SET	);

fwrite(label_from, 40, 1, fout);		//label from

fwrite(&counter, 4, 1, fout);		//# of files
fwrite(&records, 4, 1, fout);		//# of words

//length of keyword
fputc(INDEX_LENGTH, fout);

//fill by zeroes
for(f=49; f<1024; f++){
	fputc(0, fout);
}



//now will pass through all files
memset(last_word, 0, BUF_SIZE);		//no last word


for(f=1; f <= counter; f++){

	//create filename
	sprintf(buf, "%04d", f);

	//open input file
	fin = fopen(buf, "rb");
	if(fin == NULL){
		printf("Error openning input file %s \n", buf);
		return 0;
	}

	//get length of file
	fseek(fin, 0, SEEK_END);
	h = ftell(fin);

	fseek(fin, 0, SEEK_SET);		//begin

	//read all record to buffer{
	memset(one_record, 0, FILE_LENGTH);
	fread(one_record, h, 1, fin);

	fclose(fin);


	//now scan for first complete word
	memset(first_word, 0, BUF_SIZE);
	for(g=0; g<h; g++){
		if(one_record[g++] == 1){			//begin mark of the word!
			i=0;
			while(one_record[g] != 2){
				first_word[i++] = one_record[g++];
			}
			first_word[i] = 0;				//end
			break;							//from for cycle
		}
	}
	//warning?
	if(g >= h){
		printf("Error: first word of file %s was not found!\n", buf);
	}

	//FIXED: now store INDEX_LENGTH bytes *from end*
	if(strlen(first_word) <= INDEX_LENGTH)
		j=0;								//offset in first_word FROM WHICH WE WILL STORE
	else
		j=(strlen(first_word) - INDEX_LENGTH);



	//OK, store word in index from first_word[j]
	fwrite(&first_word[j], INDEX_LENGTH, 1, fout);

	if(strcmp(first_word, last_word) == 0){	//same!
		fputc(1, fout);
	}
	else{
		fputc(0, fout);
	}


	//now scan from end of file(buffer) for last word
	memset(last_word, 0, BUF_SIZE);
	g=h-1;
	while(g >= 0 && one_record[g] != 2){		//end of word
		g--;
	}

	g--;
	j=0;

	while(g >= 0 && one_record[g] != 1){		//start of word
		last_word[j++] = one_record[g];
		g--;
	}

	last_word[j++] = 0;
	//reverese
	strrev(last_word);

}


fclose(fout);

free(data);

//-------------------------------------------


///// WORK ON OPPOSITE DIRECTION

//------------------------------------------------------------------------

//now we will cut big file 2.tmp to many small, FILE_LENGTH long
//open input file
fin=fopen("2.tmp", "rb");
if(fin==NULL){
	printf("Error openning input file 2.tmp \n");
	return 0;
}

//get length of file
fseek(fin, 0, SEEK_END);
data_len = ftell(fin);

//now will read all data to memory
data = (char*) malloc (data_len * 2);
if(data == NULL){
	printf("Cannot allocate %d bytes for data!", data_len);
	return	0;
}

memset(data, 0, (data_len * 2));

//copy all data to buffer
fseek(fin, 0, SEEK_SET);
fread(data, data_len, 1, fin);




counter = 1;			//will start 0001

f=0;					//data pointer

while(f < data_len){

	//create filename: HAS INDEX i for oppositte!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	sprintf(buf, "%04di", counter);

	//open input file
	fout=fopen(buf, "wb");
	if(fout==NULL){
		printf("Error openning output file %s \n", buf);
		return 0;
	}

	//copy data
	g = FILE_LENGTH;

	if ((data_len - f) < FILE_LENGTH)
		g = data_len - f;

	fwrite(&data[f], g, 1, fout);


	fclose(fout);

	f+= FILE_LENGTH;
	counter++;
}

counter--;		//counter will be used later!


fclose(fin);

if(remove("2.tmp") != 0){
	printf("Cannot remove temp file 2.tmp");
	return	0;
}




//-------------------------------------------


//-------------------------------------------

//finally we will create index. Open each file and get first and last word
//first word is shortened to INDEX_LENGTH and flag "search in previous file too" is
//determined. (words from previous and actual file are EXACTLY same).
//file format of index and indexi:
/*
| offset|    |                                                                |
|       |    |                                                                |
|     0 |  40| Name of dictionary, unused = 0. Last char (offset 39) is 0     |
|    40 |   4| Number of all files for direction of index                     |
|    44 |   4| Number of all words                                            |
|    48 |   1| Length of keyword (INDEX_LENGTH) default value is 8            |
|    49 |    | unused bytes filled by 0                                       |

|  1024 |    |DATA AREA. Structure of data:                                   |
|       |    |INDEX_LENGTH bytes of keyword for file 0001. Unused bytes are 0 |
|       |    |1 byte flag: 0 when previous file, last record has DIFFERENT    |
|       |    |word, 1 when has EXACTLY same word                              |
|       |    |                                                                |
|       |    |INDEX_LENGTH bytes of keyword for file 0002. Unused bytes are 0 |
|       |    |1 byte flag: 0 when previous file, last record has DIFFERENT    |
|       |    |word, 1 when has EXACTLY same word                              |
|       |    |                                                                |
|       |    |...etc for all files of same direction                          |

*/

// CREATION TO=>FROM INDEX: indexi

//open output file - indexi
fout=fopen("indexi", "wb");
if(fout==NULL){
	printf("Error creating index file: indexi\n");
	return 0;
}
fseek(fout, 0, SEEK_SET	);

fwrite(label_to, 40, 1, fout);		//label to

fwrite(&counter, 4, 1, fout);		//# of files
fwrite(&records, 4, 1, fout);		//# of words

//length of keyword
fputc(INDEX_LENGTH, fout);

//fill by zeroes
for(f=49; f<1024; f++){
	fputc(0, fout);
}



//now will pass through all files
memset(last_word, 0, BUF_SIZE);		//no last word


for(f=1; f <= counter; f++){

	//create filename
	sprintf(buf, "%04di", f);

	//open input file
	fin = fopen(buf, "rb");
	if(fin == NULL){
		printf("Error openning input file %s \n", buf);
		return 0;
	}

	//get length of file
	fseek(fin, 0, SEEK_END);
	h = ftell(fin);

	fseek(fin, 0, SEEK_SET);		//begin

	//read all record to buffer{
	memset(one_record, 0, FILE_LENGTH);
	fread(one_record, h, 1, fin);

	fclose(fin);


	//now scan for first complete word
	memset(first_word, 0, BUF_SIZE);
	for(g=0; g<h; g++){
		if(one_record[g] == 1){			//begin mark of the word!
			g++;
			i=0;
			while(one_record[g] != 2){
				first_word[i++] = one_record[g++];
			}
			first_word[i] = 0;				//end
			break;							//from for cycle
		}
	}
	//warning?
	if(g >= h){
		printf("Error: first word of file %s was not found!\n", buf);
	}

	//now store INDEX_LENGTH bytes *from START*
	//OK, store word in index from first_word[j]
	fwrite(&first_word[0], INDEX_LENGTH, 1, fout);

	if(strcmp(first_word, last_word) == 0){	//same!
		fputc(1, fout);
	}
	else{
		fputc(0, fout);
	}


	//now scan from end of file(buffer) for last word
	memset(last_word, 0, BUF_SIZE);
	g=h-1;
	while(g >= 0 && one_record[g] != 2){		//end of word
		g--;
	}

	g--;
	j=0;

	while(g >= 0 && one_record[g] != 1){		//start of word
		last_word[j++] = one_record[g];
		g--;
	}

	last_word[j++] = 0;

	//reverese
	//strrev(last_word);

}


fclose(fout);

free(data);

free(index);




return 0;
}


