/*

*****************************************
prevede txt verzi slovniku na .dic format Davar3
input file je VZDY 1.txt (nemusi byt serazen)
output file je VZDY 1.dic
FORMAT 1.TXT:

slovo_from	TAB	slovo_to	TAB	type	TAB	cr+lf

(type nemusi byt pouzit, pak je TABTAB)



dale vyzaduje dve radici tabulky (TAB format)
				from.tab (pro jazyk smeru FROM)
				to.tab (pro jazyk smeru TO)
				infotag.txt
				dicname.txt


HISTORIE ZMEN:
14.3.2006	- v razeni nebyly he stringy otaceny. Udelano i pro XX-HE variantu jazyku, ale netestovano
20.11.2006	pridany 4 bytes L+SL info o jazyku FROM a TO
|   158 |     1 |MAIN LANGUAGE FROM (standard windows values are used)        |
|   159 |     1 |MAIN SUBLANGUAGE FROM (standard windows values are used)     |
|   160 |     1 |MAIN LANGUAGE TO (standard windows values are used)          |
|   161 |     1 |MAIN SUBLANGUAGE TO (standard windows values are used)       |

nacitaji se soubory: 	from_lang.txt
						to_lang.txt
(ktere maji stejny format jako pro DBK a LEX)


4.11.2007 - pridano vyhazovani opakovanych recordu - takto lze provest merge tim, ze do 1.txt
postupne za sebe vlozime nekolik slovniku!

*/




#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


//DIC_INDEX - pouzito k razeni cz slov pri vytvareni dic file
//POZOR: protoze ma Davar2.4 max. delku recordu 256 bytes, je zvolena delka cz slova
//max. 256. Pro falco slovnik (~26000 slov, delka slova 70 zn) je tedy treba alokovat cca
//7 MB, coz je unosne.
#define		DIC_TEXT_SIZE		256

typedef struct{
	unsigned char	from[DIC_TEXT_SIZE];		//from slovo
	unsigned char	to[DIC_TEXT_SIZE];			//to slovo
	unsigned char	note[2];					//note
	int				offset;						//a offset
}DIC_RECORD;


//pocet polozek
#define	LANG_MAX			71
#define	SUBLANG_MAX			93


typedef struct{
	unsigned char nazev[50];	//nazev jazyka (LANG_CZECH)
	int			  value;		//hodnota
}LANG;

typedef struct{
	unsigned char nazev[50];	//nazev POD-jazyka (SUBLANG_NEUTRAL)
	int			  value;		//hodnota
}SUBLANG;




int				f, g, h, i, j, l, r;
int				n1, n2, n3;
int				it;					//citac infotag bytes
unsigned char	flag;				//pomocna 1 byte

FILE			*fin;
FILE			*fout;

int				max=75000;
unsigned char	buf[75000];			//sem se nacte popisna cast recordu
unsigned char	infotag[75000];		//sem se nacte infotag


int				records;				//pocet recordu
int				sirka_from;				//sirka keywords FROM
int				sirka_to;				//sirka keywords TO (latin based)

int				lang_from;				//jazyk FROM: 0=latin, 1=HE, 2=GR
int				lang_to;				//jazyk TO: 0=latin, 1=HE, 2=GR
int				charset_from;			//charset TO keywords
int				charset_to;				//charset TO keywords

//int				data_max=512;		//data jsou max 256 bytes
//unsigned char	data_from[512];		//sem se nacte slovo FROM
//unsigned char	data_to[512];		//sem se nacte slovo TO
//unsigned char	data_note[512];		//sem se nacte slovo TO

unsigned char 		razeni[4][512];	//POLE razeni, nacitame z tab souboru!
									//[0]=razeni FROM
									//[1]=mapa znaku FROM
									//[2]=razeni TO
									//[3]=mapa znaku TO
									//ABECEDNI poradi znaku. Kazdy znak jsou DVA bajty!
									//V kazdem poli byt ALESPON na poslednim miste 0 0!
									//Normalni znaky: 'a' 0, 'b' 0, 'c' 0, ....
				 					//Sprezky:        ... 'C''h', 'c''h', 'i' 0, .....
									//POZOR: sprezka NESMI!!! mit druhy znak \0!

									//PAK nasleduji "mapy" stejnych znaku, tj. tech, ktere jsou si rovny.
									//Protoze v "hlavni" radici tabulce jsou uz znaky serazeny, ukolem mapy
									//je oznacit, ZE NASLEDUJICI znak (v hlavni tabulce) si je s timto rovny (=1),
									//nebo nerovny (=0)
									//PLATNY JE ALE JEN PRVNI BAJT MAPY, druhy se ignoruje!


unsigned char 		mapa_from[32];		//sem se SPOCITA bitova mapa razeni z pole razeni[1][512]
unsigned char 		mapa_to[32];		//sem se SPOCITA bitova mapa razeni z pole razeni[3][512]

DIC_RECORD			*rec;				//pointer na dynamicky alloc. bufer DIC_RECORD struktury
DIC_RECORD			*rec_clean;			//to same-sem se z *rec kopiruji NEOPAKOVANE recordy

unsigned char		dicname_from[256];	//nazev slovniku
unsigned char		dicname_to[256];	//nazev slovniku


int				from_language=0;		//hodnoty nactene z from_lang.txt, inic na 0=neutral
int				from_sublanguage=0;		//hodnoty nactene z from_lang.txt, inic na 0=neutral
int				to_language=0;			//hodnoty nactene z to_lang.txt, inic na 0=neutral
int				to_sublanguage=0;		//hodnoty nactene z to_lang.txt, inic na 0=neutral
//poznamename si i indexy v poli-vypis bude POZDEJI
int				i1,i2,i3,i4;


int				LNG_BUF_SIZE=300;
unsigned char	lng_buf[300];			//
unsigned char	sublng_buf[300];		//


int				deleted;				//pocet smazanych opakovanych recordu
int				rec_compare;			//index recordu, ktery se porovnava s dalsimi-pro pripadne mazani


//prototypy
signed int dic_qsortcompareFROM( const void *arg1, const void *arg2 );
signed int dic_qsortcompareTO( const void *arg1, const void *arg2 );
signed int PorovnejRetezce(unsigned char *a, unsigned char *b, unsigned char *tab);



int main()
{


LANG	lang[LANG_MAX] = {

"LANG_NEUTRAL",                     0x00,
"LANG_AFRIKAANS",                   0x36,
"LANG_ALBANIAN",                    0x1c,
"LANG_ARABIC",                      0x01,
"LANG_ARMENIAN",                    0x2b,
"LANG_ASSAMESE",                    0x4d,
"LANG_AZERI",                       0x2c,
"LANG_BASQUE",                      0x2d,
"LANG_BELARUSIAN",                  0x23,
"LANG_BENGALI",                     0x45,
"LANG_BULGARIAN",                   0x02,
"LANG_CATALAN",                     0x03,
"LANG_CHINESE",                     0x04,
"LANG_CROATIAN",                    0x1a,
"LANG_CZECH",                       0x05,
"LANG_DANISH",                      0x06,
"LANG_DUTCH",                       0x13,
"LANG_ENGLISH",                     0x09,
"LANG_ESTONIAN",                    0x25,
"LANG_FAEROESE",                    0x38,
"LANG_FARSI",                       0x29,
"LANG_FINNISH",                     0x0b,
"LANG_FRENCH",                      0x0c,
"LANG_GEORGIAN",                    0x37,
"LANG_GERMAN",                      0x07,
"LANG_GREEK",                       0x08,
"LANG_GUJARATI",                    0x47,
"LANG_HEBREW",                      0x0d,
"LANG_HINDI",                       0x39,
"LANG_HUNGARIAN",                   0x0e,
"LANG_ICELANDIC",                   0x0f,
"LANG_INDONESIAN",                  0x21,
"LANG_ITALIAN",                     0x10,
"LANG_JAPANESE",                    0x11,
"LANG_KANNADA",                     0x4b,
"LANG_KASHMIRI",                    0x60,
"LANG_KAZAK",                       0x3f,
"LANG_KONKANI",                     0x57,
"LANG_KOREAN",                      0x12,
"LANG_LATVIAN",                     0x26,
"LANG_LITHUANIAN",                  0x27,
"LANG_MACEDONIAN",                  0x2f,
"LANG_MALAY",                       0x3e,
"LANG_MALAYALAM",                   0x4c,
"LANG_MANIPURI",                    0x58,
"LANG_MARATHI",                     0x4e,
"LANG_NEPALI",                      0x61,
"LANG_NORWEGIAN",                   0x14,
"LANG_ORIYA",                       0x48,
"LANG_POLISH",                      0x15,
"LANG_PORTUGUESE",                  0x16,
"LANG_PUNJABI",                     0x46,
"LANG_ROMANIAN",                    0x18,
"LANG_RUSSIAN",                     0x19,
"LANG_SANSKRIT",                    0x4f,
"LANG_SERBIAN",                     0x1a,
"LANG_SINDHI",                      0x59,
"LANG_SLOVAK",                      0x1b,
"LANG_SLOVENIAN",                   0x24,
"LANG_SPANISH",                     0x0a,
"LANG_SWAHILI",                     0x41,
"LANG_SWEDISH",                     0x1d,
"LANG_TAMIL",                       0x49,
"LANG_TATAR",                       0x44,
"LANG_TELUGU",                      0x4a,
"LANG_THAI",                        0x1e,
"LANG_TURKISH",                     0x1f,
"LANG_UKRAINIAN",                   0x22,
"LANG_URDU",                        0x20,
"LANG_UZBEK",                       0x43,
"LANG_VIETNAMESE",                  0x2a
											};

SUBLANG	sublang[SUBLANG_MAX] = {


"SUBLANG_NEUTRAL",                  0x00,
"SUBLANG_DEFAULT",                  0x01,
"SUBLANG_SYS_DEFAULT",              0x02,
"SUBLANG_ARABIC_SAUDI_ARABIA",      0x01,
"SUBLANG_ARABIC_IRAQ",              0x02,
"SUBLANG_ARABIC_EGYPT",             0x03,
"SUBLANG_ARABIC_LIBYA",             0x04,
"SUBLANG_ARABIC_ALGERIA",           0x05,
"SUBLANG_ARABIC_MOROCCO",           0x06,
"SUBLANG_ARABIC_TUNISIA",           0x07,
"SUBLANG_ARABIC_OMAN",              0x08,
"SUBLANG_ARABIC_YEMEN",             0x09,
"SUBLANG_ARABIC_SYRIA",             0x0a,
"SUBLANG_ARABIC_JORDAN",            0x0b,
"SUBLANG_ARABIC_LEBANON",           0x0c,
"SUBLANG_ARABIC_KUWAIT",            0x0d,
"SUBLANG_ARABIC_UAE",               0x0e,
"SUBLANG_ARABIC_BAHRAIN",           0x0f,
"SUBLANG_ARABIC_QATAR",             0x10,
"SUBLANG_AZERI_LATIN",              0x01,
"SUBLANG_AZERI_CYRILLIC",           0x02,
"SUBLANG_CHINESE_TRADITIONAL",      0x01,
"SUBLANG_CHINESE_SIMPLIFIED",       0x02,
"SUBLANG_CHINESE_HONGKONG",         0x03,
"SUBLANG_CHINESE_SINGAPORE",        0x04,
"SUBLANG_CHINESE_MACAU",            0x05,
"SUBLANG_DUTCH",                    0x01,
"SUBLANG_DUTCH_BELGIAN",            0x02,
"SUBLANG_ENGLISH_US",               0x01,
"SUBLANG_ENGLISH_UK",               0x02,
"SUBLANG_ENGLISH_AUS",              0x03,
"SUBLANG_ENGLISH_CAN",              0x04,
"SUBLANG_ENGLISH_NZ",               0x05,
"SUBLANG_ENGLISH_EIRE",             0x06,
"SUBLANG_ENGLISH_SOUTH_AFRICA",     0x07,
"SUBLANG_ENGLISH_JAMAICA",          0x08,
"SUBLANG_ENGLISH_CARIBBEAN",        0x09,
"SUBLANG_ENGLISH_BELIZE",           0x0a,
"SUBLANG_ENGLISH_TRINIDAD",         0x0b,
"SUBLANG_ENGLISH_ZIMBABWE",         0x0c,
"SUBLANG_ENGLISH_PHILIPPINES",      0x0d,
"SUBLANG_FRENCH",                   0x01,
"SUBLANG_FRENCH_BELGIAN",           0x02,
"SUBLANG_FRENCH_CANADIAN",          0x03,
"SUBLANG_FRENCH_SWISS",             0x04,
"SUBLANG_FRENCH_LUXEMBOURG",        0x05,
"SUBLANG_FRENCH_MONACO",            0x06,
"SUBLANG_GERMAN",                   0x01,
"SUBLANG_GERMAN_SWISS",             0x02,
"SUBLANG_GERMAN_AUSTRIAN",          0x03,
"SUBLANG_GERMAN_LUXEMBOURG",        0x04,
"SUBLANG_GERMAN_LIECHTENSTEIN",     0x05,
"SUBLANG_ITALIAN",                  0x01,
"SUBLANG_ITALIAN_SWISS",            0x02,
"SUBLANG_KASHMIRI_INDIA",           0x02,
"SUBLANG_KOREAN",                   0x01,
"SUBLANG_LITHUANIAN",               0x01,
"SUBLANG_LITHUANIAN_CLASSIC",       0x02,
"SUBLANG_MALAY_MALAYSIA",           0x01,
"SUBLANG_MALAY_BRUNEI_DARUSSALAM",  0x02,
"SUBLANG_NEPALI_INDIA",             0x02,
"SUBLANG_NORWEGIAN_BOKMAL",         0x01,
"SUBLANG_NORWEGIAN_NYNORSK",        0x02,
"SUBLANG_PORTUGUESE",               0x02,
"SUBLANG_PORTUGUESE_BRAZILIAN",     0x01,
"SUBLANG_SERBIAN_LATIN",            0x02,
"SUBLANG_SERBIAN_CYRILLIC",         0x03,
"SUBLANG_SPANISH",                  0x01,
"SUBLANG_SPANISH_MEXICAN",          0x02,
"SUBLANG_SPANISH_MODERN",           0x03,
"SUBLANG_SPANISH_GUATEMALA",        0x04,
"SUBLANG_SPANISH_COSTA_RICA",       0x05,
"SUBLANG_SPANISH_PANAMA",           0x06,
"SUBLANG_SPANISH_DOMINICAN_REPUBLIC", 0x07,
"SUBLANG_SPANISH_VENEZUELA",        0x08,
"SUBLANG_SPANISH_COLOMBIA",         0x09,
"SUBLANG_SPANISH_PERU",             0x0a,
"SUBLANG_SPANISH_ARGENTINA",        0x0b,
"SUBLANG_SPANISH_ECUADOR",          0x0c,
"SUBLANG_SPANISH_CHILE",            0x0d,
"SUBLANG_SPANISH_URUGUAY",          0x0e,
"SUBLANG_SPANISH_PARAGUAY",         0x0f,
"SUBLANG_SPANISH_BOLIVIA",          0x10,
"SUBLANG_SPANISH_EL_SALVADOR",      0x11,
"SUBLANG_SPANISH_HONDURAS",         0x12,
"SUBLANG_SPANISH_NICARAGUA",        0x13,
"SUBLANG_SPANISH_PUERTO_RICO",      0x14,
"SUBLANG_SWEDISH",                  0x01,
"SUBLANG_SWEDISH_FINLAND",          0x02,
"SUBLANG_URDU_PAKISTAN",            0x01,
"SUBLANG_URDU_INDIA",               0x02,
"SUBLANG_UZBEK_LATIN",              0x01,
"SUBLANG_UZBEK_CYRILLIC",           0x02
											};





// --------- NATAZENI RADICI TABULKY FROM a modifikace struktury tabulky v pameti ---------

fin=fopen("from.tab", "rt");		//cteni v text rezimu!

if(fin==NULL){					//nelze otevrit tabulku!
	printf("*ERROR* Cannot open sorting table from.tab!");
	return 0;
}


//OK, file uspesne otevren. Kazdy radek nacteme do buffru tak dlouho, dokud
//neni # (poznamka) nebo \n. Pokud je buffer delsi nez 0 znaku, pak jej cteme.
//ocekavame 3 integer cisla oddelena ','. Pokud nacteme 0,0,0 jde o posledni radek!
fseek(fin, 0, SEEK_SET);		//na zacatek
memset(&razeni[0][0], 0, 512);	//nuluj tabulku razeni
memset(&razeni[1][0], 0, 512);	//nuluj tabulku map
h=0;								//citac radku trojic cisel

while(1){							//POZOR: MUSI byt ukonceni 0,0,0 jinak to fakt ZATUHNE!!!
	memset(buf, 0, max);	//nuluj buffer
	f=0;					//pocet nactenych znaku
	while(g=fgetc(fin), (g !='\n' && g != '#')){	//do konce radku nebo #
		buf[f]=(unsigned char)g;
		f++;
	}
	//pokud g!='\n', pak cti az do konce radku
	if(g!='\n'){
		while(g=fgetc(fin), (g !='\n') )
			;
	}
	// do buf[] pridej koncovy znak \0, JEN POKUD JE DELSI NEZ 0 NACTENYCH ZNAKU!
	//pak to zpracuj
	if(f==0)			//nebyl radek s cisly
		continue;		//dalsi pruchod

	//zpracovavame to!
	buf[++f]=0;					//dopln nulovy znak na konec
	sscanf(buf,"%d,%d,%d", &n1, &n2, &n3);		//nacteme cisla

	razeni[0][2*h]=n1;		//znak1
	razeni[0][2*h+1]=n2;	//znak2
	razeni[1][2*h]=n3;		//mapa
	h++;

	if(!(n1 | n2 | n3))			//zadano 0,0,0=>konec tabulky
		break;

	if(h>255)
		break;					//ochrana, pokud je zadano vice radku, at nepiseme do cizi pameti!

}
fclose(fin);

// --------- NATAZENI RADICI TABULKY FROM ---------


// --------- NATAZENI RADICI TABULKY TO a modifikace struktury tabulky v pameti ---------

fin=fopen("to.tab", "rt");		//cteni v text rezimu!

if(fin==NULL){					//nelze otevrit tabulku!
	printf("*ERROR* Cannot open sorting table to.tab!");
	return 0;
}


//OK, file uspesne otevren. Kazdy radek nacteme do buffru tak dlouho, dokud
//neni # (poznamka) nebo \n. Pokud je buffer delsi nez 0 znaku, pak jej cteme.
//ocekavame 3 integer cisla oddelena ','. Pokud nacteme 0,0,0 jde o posledni radek!
fseek(fin, 0, SEEK_SET);		//na zacatek
memset(&razeni[2][0], 0, 512);	//nuluj tabulku razeni
memset(&razeni[3][0], 0, 512);	//nuluj tabulku map
h=0;								//citac radku trojic cisel

while(1){							//POZOR: MUSI byt ukonceni 0,0,0 jinak to fakt ZATUHNE!!!
	memset(buf, 0, max);	//nuluj buffer
	f=0;					//pocet nactenych znaku
	while(g=fgetc(fin), (g !='\n' && g != '#')){	//do konce radku nebo #
		buf[f]=(unsigned char)g;
		f++;
	}
	//pokud g!='\n', pak cti az do konce radku
	if(g!='\n'){
		while(g=fgetc(fin), (g !='\n') )
			;
	}
	// do buf[] pridej koncovy znak \0, JEN POKUD JE DELSI NEZ 0 NACTENYCH ZNAKU!
	//pak to zpracuj
	if(f==0)			//nebyl radek s cisly
		continue;		//dalsi pruchod

	//zpracovavame to!
	buf[++f]=0;					//dopln nulovy znak na konec
	sscanf(buf,"%d,%d,%d", &n1, &n2, &n3);		//nacteme cisla

	razeni[2][2*h]=n1;		//znak1
	razeni[2][2*h+1]=n2;	//znak2
	razeni[3][2*h]=n3;		//mapa
	h++;

	if(!(n1 | n2 | n3))			//zadano 0,0,0=>konec tabulky
		break;

	if(h>255)
		break;					//ochrana, pokud je zadano vice radku, at nepiseme do cizi pameti!

}
fclose(fin);

// --------- NATAZENI RADICI TABULKY TO ---------



//do pole mapa_from[] spocteme BITOVOU mapu z pole razeni[1][512]
memset(mapa_from, 0, 32);
for(g=0; g<32; g++){
	flag=0;					//sem to pocitame...
	for(f=0; f<8; f++){
		flag = flag << 1;	//otacet nesmime ZA nastavenim bitu!
		h=(g*16)+(f*2);		//BUG!
		if(razeni[1][h]){		//je nastaven kazdy druhy byte na 1?
			flag = 1 | flag;				//nastav PRISLUSNY BIT
		}
	}

	mapa_from[g]=flag;
}

//do pole mapa_to[] spocteme BITOVOU mapu z pole razeni[3][512]
memset(mapa_to, 0, 32);
for(g=0; g<32; g++){
	flag=0;					//sem to pocitame...
	for(f=0; f<8; f++){
		flag = flag << 1;	//otacet nesmime ZA nastavenim bitu!
		h=(g*16)+(f*2);		//BUG!
		if(razeni[3][h]){		//je nastaven kazdy druhy byte na 1?
			flag = 1 | flag;				//nastav PRISLUSNY BIT
		}
	}

	mapa_to[g]=flag;
}


// --------- NATAZENI INFOTAG do pameti ---------

//open infotag.txt file
fin=fopen("infotag.txt", "r");
if(fin==NULL){
	printf("*ERROR* Cannot open file infotag.txt\n");
	return 0;
}

fseek(fin, 0, SEEK_SET);
memset(infotag, 0, max);

//nacteme cely do bufferu
it=0;
while(g=fgetc(fin), (g!=EOF && it<max)){
	if(g=='\n'){
		infotag[it++]=13;	//at mame cr+lf
		infotag[it++]=10;
		continue;
	}
	infotag[it++]=g;
}

if(infotag[it-1] == 13 || infotag[it-1] == 10){	//je tam zbytkovy CR nebo LF?
	infotag[it-1] = 0;							//orez
	it--;										//zmensi delku
}
if(infotag[it-1] == 13 || infotag[it-1] == 10){	//je tam zbytkovy CR nebo LF?
	infotag[it-1] = 0;							//orez
	it--;										//zmensi delku
}
//infotag je v bufferu a zname delku: it
fclose(fin);

// --------- NATAZENI INFOTAG do pameti ---------


// --------- NATAZENI dicname.txt ---------

//open dicname.txt file
fin=fopen("dicname.txt", "r");
if(fin==NULL){
	printf("*ERROR* Cannot open file dicname.txt\n");
	return 0;
}

fseek(fin, 0, SEEK_SET);
memset(dicname_from, 0, 256);
memset(dicname_to, 0, 256);

//cekame format: texty max 63 znaku!
//POZOR: jiny format nez he22dic!!!

//	Hebrew-Czech dictionary\n			//FROM string nazvu
//	1									//FROM language 0=latin, 1=HE, 2=GR
//	0									//FROM charset
//	Czech-Hebrew dictionary\n			//TO string nazvu
//	0									//TO language 0=latin, 1=HE, 2=GR
//	238									//TO charset
//	\n\n muzou byt


//nacteme FROM do bufferu

//preskoc nezadouci znaky
while(g=fgetc(fin), (g!=EOF && (g==13 || g==10)))
	;
ungetc(g,fin);

f=0;
//cteni from
while(g=fgetc(fin), (g!=EOF && f<256 && g!=13 && g!=10)){
	dicname_from[f++]=g;
}

//preskoc nezadouci znaky
while(g=fgetc(fin), (g!=EOF && (g==13 || g==10)))
	;
ungetc(g,fin);

//cteni lang_from
fscanf(fin, "%d\n", &lang_from);
//cteni charset_from
fscanf(fin, "%d\n", &charset_from);


f=0;
//cteni to
while(g=fgetc(fin), (g!=EOF && f<256 && g!=13 && g!=10)){
	dicname_to[f++]=g;
}

//cteni lang_to
fscanf(fin, "%d\n", &lang_to);
//cteni charset_to
fscanf(fin, "%d\n", &charset_to);

//ted tvrdy orez
dicname_from[63]=0;
dicname_to[63]=0;


fclose(fin);

// --------- NATAZENI dicname.txt ---------

// --------- ZPRACOVANI dvou"_lang.txt" souboru ---------


//Pridano: d3 pouziva i language definici FROM/TO jazyka. Ty v D2 file nemame, musime je nacist z externiho file
//files "_lang.txt" MUSI existovat!!! - jinak se zapise lang neutral: 0, 0 LANG/SUBLANG
//format:
//LANG_ENGLISH, SUBLANG_NEUTRAL[CR+LF]: carka a mezera MUSI byt!


// from_lang.txt
	fin=fopen("from_lang.txt", "r");
	if(fin==NULL){
		printf("*ERROR: FROM Language file from_lang.txt file NOT FOUND\n");
	}
	else{

		fseek(fin, 0, SEEK_SET);

		memset(lng_buf, 0, LNG_BUF_SIZE);
		memset(sublng_buf, 0, LNG_BUF_SIZE);

		//Nacteme stringy
		fscanf(fin, "%s %s\n", lng_buf, sublng_buf);

		//Scanujeme na lang a sublang

		for(f=0; f<LANG_MAX; f++){
			if(strcmp(lng_buf, lang[f].nazev) == 0){
				from_language = 	lang[f].value;
				i1=f;				//ulozime index pro pozdejsi vypis
				break;
			}
		}
		if(f>=LANG_MAX)
			printf("*ERROR: LANGUAGE was not found in from_lang.txt\n");


		for(f=0; f<SUBLANG_MAX; f++){
			if(strcmp(sublng_buf, sublang[f].nazev) == 0){
				from_sublanguage = 	sublang[f].value;
				i2=f;				//ulozime index pro pozdejsi vypis
				break;
			}
		}

		if(f>=SUBLANG_MAX)
			printf("*ERROR: SUBLANGUAGE was not found in from_lang.txt\n");


		fclose(fin);
	}

// to_lang.txt
	fin=fopen("to_lang.txt", "r");
	if(fin==NULL){
		printf("*ERROR: TO Language file to_lang.txt file NOT FOUND\n");
	}
	else{

		fseek(fin, 0, SEEK_SET);

		memset(lng_buf, 0, LNG_BUF_SIZE);
		memset(sublng_buf, 0, LNG_BUF_SIZE);

		//Nacteme stringy
		fscanf(fin, "%s %s\n", lng_buf, sublng_buf);

		//Scanujeme na lang a sublang

		for(f=0; f<LANG_MAX; f++){
			if(strcmp(lng_buf, lang[f].nazev) == 0){
				to_language = 	lang[f].value;
				i3=f;				//ulozime index pro pozdejsi vypis
				break;
			}
		}
		if(f>=LANG_MAX)
			printf("*ERROR: LANGUAGE was not found in to_lang.txt\n");



		for(f=0; f<SUBLANG_MAX; f++){
			if(strcmp(sublng_buf, sublang[f].nazev) == 0){
				to_sublanguage = 	sublang[f].value;
				i4=f;				//ulozime index pro pozdejsi vypis
				break;
			}
		}

		if(f>=SUBLANG_MAX)
			printf("*ERROR: SUBLANGUAGE was not found in to_lang.txt\n");


		fclose(fin);
	}



//---- zpracovani 1.txt --------------------


//Otevreme  soubor

//open input file
fin=fopen("1.txt", "rb");
if(fin==NULL){
	printf("Error openning input file 1.txt \n");
	return 0;
}


//open output file - 1.dic
fout=fopen("1.dic", "wb");
if(fout==NULL){
	printf("Error creating output file 1.dic\n");
	return 0;
}

fseek(fin, 0, SEEK_SET	);
fseek(fout, 0, SEEK_SET	);


//oba otevreny

///// 1.pruchod 1.TXT=> zjistime delku nejdelsiho recordu a pocet recordu(==radku)

records=0;
h=0;			//delka max nalezeneho stringu
while(g=fgetc(fin), (g != EOF)){
	ungetc(g,fin);					//vrat znak
	f=0;
	while(g=fgetc(fin), (g != '\t' && g != EOF))
		f++;

	if(f==0)
		break;						//prazdny record=>ven!
	if(f>h)
		h=f;						//FROM

	f=0;
	while(g=fgetc(fin), (g != '\t' && g != EOF))
		f++;

	if(f==0)
		break;						//prazdny record=>ven!
	if(f>h)
		h=f;						//TO

	f=0;
	while(g=fgetc(fin), (g != '\t' && g != EOF))
		f++;
	if(f>h)
		h=f;						//NOTE

	//nacteno 13, jeste preskocime 10
	fgetc(fin);

	records++;
}

//OK, records udava pocet nalezenych platnych zaznamu, h nejdelsi string. Muzeme alokovat pamet!
//FIXME: alokujeme velmi benevolentne. Pokud bude u vetsich souboru problem, muzeme redukovat DIC_TEXT_SIZE

	printf("%d records found in 1.txt file\n", records);
	printf("%d characters is maximum length of item\n", h);
	//potrebna delka pro jeden record: mame NATVRDO reservovano DIC_TEXT_SIZE jako max delku stringu slova, pokud
	//je to delsi, jdeme VEN!!
	if(h >= DIC_TEXT_SIZE){
		printf("*FATAL ERROR* length of item is too long (%d reserved, found %d)\n", DIC_TEXT_SIZE, h);
		return 0;
	}
	else{	//OK, alokujeme

		rec = (DIC_RECORD*)malloc(records * sizeof(DIC_RECORD));
		if(rec == NULL){
			printf("*FATAL ERROR* cannot allocate %d bytes\n", records * sizeof(DIC_RECORD));
			return 0;
		}
		else{
			printf("%d bytes allocated for sorting\n", records * sizeof(DIC_RECORD) );
			//vypiseme dodatecne informace o jazyku a charsetu
			printf("Dictionary parameters, as found in dictname.txt file:\n");
			printf("Type FROM = %d [0=latin based, 1=Hebrew, 2=Greek]\n", lang_from);
			printf("Charset  FROM = %d [0=ANSI, 238=EastEurope, 162=Turkish, 204=Russian]\n", charset_from);
			printf("Type TO   = %d [0=latin based, 1=Hebrew, 2=Greek]\n", lang_to);
			printf("Charset  TO   = %d [0=ANSI, 238=EastEurope, 162=Turkish, 204=Russian]\n\n", charset_to);
			printf("Language and Sublanguage parameters, as found in from_lang.txt and to_lang.txt:\n");
			printf("Language FROM = %s\n", lang[i1].nazev);
			printf("Sublanguage FROM = %s\n", sublang[i2].nazev);
			printf("Language TO = %s\n", lang[i3].nazev);
			printf("Sublanguage TO = %s\n", sublang[i4].nazev);
			printf("---------------------------------------------------------------\n\n");
		}
	}

///PRIDANO: alokujeme  stejne mnozstvi i pro *rec_clean - mazani opakovanych recordu
		rec_clean = (DIC_RECORD*)malloc(records * sizeof(DIC_RECORD));
		if(rec_clean == NULL){
			printf("*FATAL ERROR* cannot allocate %d bytes for rec_clean buffer\n", records * sizeof(DIC_RECORD));
			return 0;
		}



	//OK, mame pamet, nyni druhy pruchod-cteme jednotlive recordy
	memset(rec, 0, (records * sizeof(DIC_RECORD)));
	fseek(fin, 0, SEEK_SET	);
	fseek(fout, 0, SEEK_SET	);

	///// 2.pruchod 1.TXT=> nacteme jednotlive recordy do pameti

	for(f=0; f<records; f++){		//cteme vsechny recordy, pocet je znam

		i=0;
		while(g=fgetc(fin), (g != '\t' && g != EOF))
			rec[f].from[i++] = (unsigned char)g;


		i=0;
		while(g=fgetc(fin), (g != '\t' && g != EOF))
			rec[f].to[i++] = (unsigned char)g;

		g=fgetc(fin);				//bud NOTE nebo \t pokud chybi

		if(g == '\t'){
			rec[f].note[0] = 0;	//note znak chybi
		}
		else{
			rec[f].note[0] = (unsigned char)g;	//note znak je
			rec[f].note[1] = 0;
			g=fgetc(fin);				//docteme \t znak!
		}


		g=fgetc(fin);				//13
		g=fgetc(fin);				//10

		//tisk:
		//printf("%d:  %s=>%s %s\n", f, rec[f].from, rec[f].to, rec[f].note);
	}

	//mame vsechna data nactena, ted seradit - dle from!! input nemusi byt serazen!!
	printf("\nQuick-sorting input data ...\n");
	qsort(&rec[0].from, (size_t) records, (size_t)sizeof(DIC_RECORD), dic_qsortcompareFROM);


	//vypis po serazeni
//	for(f=0; f<records; f++){		//cteme vsechny recordy, pocet je znam
//		printf("%d %s %s %s\n", f, rec[f].from, rec[f].to, rec[f].note);
//	}

	//OK, recordy serazene.



//// PRIDANO: nyni muzeme provest vymazani opakovanych recordu, jedinecne recordy se kopiruji do rec_clean

	deleted=0;							//smazanych
	rec_compare = 0;					//s timto se bude porovanavat

	//prvni record proste kopirujeme
	rec_clean[0] = rec[0];
	rec_compare = 0;

	g = 1;								//index, kam zapisujeme neopakovane do rec_clean[]

	for(f=1; f<records; f++){			//cteme od druheho [=1] vsechny recordy a kopirujeme neopakovatelne


		//POZOR: zatim neporovnavame opakovani .note clenu!!!
		if( strcmp(rec[f].from, rec[rec_compare].from) == 0 &&
			strcmp(rec[f].to, rec[rec_compare].to) == 0 		){


			//tento record je opakovany!
			deleted++;							//smazan
			continue;
		}
		else{
			//jedinecny record!
			rec_clean[g++] = rec[f];
			rec_compare = f;
		}

	}

	printf("\n %d duplicated records were removed \n", deleted);

	//ted mame g records!!!!
	records = g;

	//zpetne kopirujeme do rec[]
	for(f=0; f<records; f++){			//cteme od druheho [=1] vsechny recordy a kopirujeme neopakovatelne
		rec[f] = rec_clean[f];
	}

	free(rec_clean);

	//at zase muzeme pouzivat rec[]

////END  PRIDANO: nyni muzeme provest vymazani opakovanych recordu, jedinecne recordy se kopiruji do rec_clean




//!!! uz prevedeno do dicname.txt !!!
//TADY OD USERA ZJISTIT CHARSETY:
//lang_from	= 0;
//lang_to		= 0;
//charset_from= 0;
//charset_to=   238;



//vytvoorime, co jde do 1.dic v 1.pruchodu
//vytvarime, co lze v 1. pruchodu: hlavicka
fputc('h', fout);
fputc('b', fout);
fputc('d', fout);
fputc('i', fout);		//id string

fputc(5, fout);			//verze 5 formatu dic

//language from
fputc((unsigned char)lang_from, fout);				//byl bug!

//language to
fputc((unsigned char)lang_to, fout);

//charset from
fputc((unsigned char)charset_from, fout);			// charset

//charset to
fputc((unsigned char)charset_to, fout);				//charset

//charset NOTE: dame vzdy EN
fputc(0, fout);			//EN

//jsme na off 10: offset dict tag info, vzdy 1024+1088
f=1024+1088;
fwrite(&f, 4, 1, fout);


//off.14  index opacneho dict. zname, je to 1024+1088+delka infotagu (it)
f=1024+1088+it;
fwrite(&f, 4, 1, fout);

//off.18  offset data slovniku-zname, je to 1024+1088+it+(pocet recordu * 4)
f=1024+1088+it+(4 * records);
fwrite(&f, 4, 1, fout);

//off.22  pocet recordu zname
fwrite(&records, 4, 1, fout);

//off.26-29: reserved, 0
fputc(0, fout);
fputc(0, fout);
fputc(0, fout);
fputc(0, fout);

//off.30-93: nazev dic FROM
fwrite(dicname_from, 64, 1, fout);

//off.94-157: nazev dic TO
fwrite(dicname_to, 64, 1, fout);

//pridano: 158-161: 4 bytes o jazyku from+to
//|   158 |     1 |MAIN LANGUAGE FROM (standard windows values are used)        |
//|   159 |     1 |MAIN SUBLANGUAGE FROM (standard windows values are used)     |
//|   160 |     1 |MAIN LANGUAGE TO (standard windows values are used)          |
//|   161 |     1 |MAIN SUBLANGUAGE TO (standard windows values are used)       |
fputc(from_language, fout);
fputc(from_sublanguage, fout);
fputc(to_language, fout);
fputc(to_sublanguage, fout);


//of.162-1024: 0
for(f=162; f<1024; f++)
	fputc(0, fout);			//nuluj



//ulozime radici tabulky
//FROM:
for(f=0; f<256; f++){
	fputc(razeni[0][2*f], fout);			//n1
	fputc(razeni[0][2*f+1], fout);			//n2
}
//mapa FROM:
for(f=0; f<32; f++){
	fputc(mapa_from[f], fout);
}


//TO:
for(f=0; f<256; f++){
	fputc(razeni[2][2*f], fout);			//n1
	fputc(razeni[2][2*f+1], fout);			//n2
}
//mapa TO:
for(f=0; f<32; f++){
	fputc(mapa_to[f], fout);
}


//ulozime TAG info dict. je to v bufferu, delka znama
fwrite(&infotag, it, 1, fout);

//zatim ulozime same nuly-PAK PREPISEME INDEXEM opacneho slovniku
for(f=0; f<(4 * records); f++){
	fputc(0, fout);
}


//////  ulozeni vlastnich dat /////////


for(f=0; f<records; f++){		//cteme vsechny recordy, pocet je znam

	sirka_from	= strlen(rec[f].from);
	sirka_to	= strlen(rec[f].to);


	//zpracujeme
	//strrev(data_from);			//he je naopak

	//ulozit offset kam zapisujeme - do indexovaci struktury
	rec[f].offset = ftell(fout);

	//	printf("Record: %d   HE:%s   CZ:%s  NOTE:%s\n", f+1, data_from, data_to, data_note);
	fprintf(fout, "|S2,%d,%d,%d,%d,",1+strlen(rec[f].from), 1+strlen(rec[f].to), 1+strlen(rec[f].note), f+1);	//1.cast, delky vcetne \0

	fwrite(rec[f].from,strlen(rec[f].from),1,fout);
	fputc(0, fout);

	fwrite(rec[f].to,strlen(rec[f].to),1,fout);
	fputc(0, fout);

	fwrite(rec[f].note,strlen(rec[f].note),1,fout);
	fputc(0, fout);

}
//f drzi pocet recordu (bez smazanych, ve file). Budeme potrebovat pro qsort!

//ted provedeme serazeni dle TO v indexu.

printf("\nQuick-sorting index...\n");

qsort(&rec[0].from, (size_t) f, (size_t)sizeof(DIC_RECORD), dic_qsortcompareTO);	//POZOR: &rec[0].from je adresa 1. recordu!!!

//zapis indexu do file
printf("\nWrite index to dictionary...\n");

fseek(fout, 1024+1088+it, SEEK_SET);

for(f=0; f<records; f++){		//vsechny recordy
	//zapis offsetu
	fwrite(&rec[f].offset, 4, 1, fout);
}


printf("\nDONE!\n");



free(rec);
fclose(fin);
fclose(fout);



return 0;
}


//---- FROM  Porovnavaci funkce pro razeni indexu dic ------------------
//IN: pointery na dva argumenty: i, j
//OUT: i<j: -1, i>j:1, i=j:0
//Funkce nejdrive do GLOBALNIHO bufferu nacte oba stringy a pak
//vola externi porovnavaci funkci. Jeji vysledek vraci.
signed int dic_qsortcompareFROM( const void *arg1, const void *arg2 )
{
unsigned char buf1[DIC_TEXT_SIZE];
unsigned char buf2[DIC_TEXT_SIZE];


//kopirujeme do bufferu, dle sirky recordu (DIC_TEXT_SIZE) a jeste doplnime \0!
memcpy(buf1, arg1, DIC_TEXT_SIZE);
memcpy(buf2, arg2, DIC_TEXT_SIZE);
buf1[DIC_TEXT_SIZE-1]=0;					//pro jistotu doplnime nulou!
buf2[DIC_TEXT_SIZE-1]=0;					//pro jistotu doplnime nulou!

//FIXED: pokud jsou FROM stringy hebrejske, musime OTOCIT!!!
if(lang_from == 1){
	strrev(buf1);
	strrev(buf2);
}



//POZOR: tabulka musi byt tabulka prislusneho slovniku!
//dle FROM tabulky
return(PorovnejRetezce(buf1, buf2,  &razeni[0][0] ));	//dle FROM slova, mapa je 512 bytes ZA tim
}

//----------------------------------------------------------

//---- TO  Porovnavaci funkce pro razeni indexu dic ------------------
//IN: pointery na dva argumenty: i, j
//OUT: i<j: -1, i>j:1, i=j:0
//Funkce nejdrive do GLOBALNIHO bufferu nacte oba stringy a pak
//vola externi porovnavaci funkci. Jeji vysledek vraci.
signed int dic_qsortcompareTO( const void *arg1, const void *arg2 )
{
unsigned char buf1[DIC_TEXT_SIZE];
unsigned char buf2[DIC_TEXT_SIZE];


//kopirujeme do bufferu, dle sirky recordu (DIC_TEXT_SIZE) a jeste doplnime \0!
//POZOR: musime ziskat strng .to k porovnani!!!!!!!!!
memcpy(buf1, (unsigned char*)arg1+DIC_TEXT_SIZE, DIC_TEXT_SIZE);
memcpy(buf2, (unsigned char*)arg2+DIC_TEXT_SIZE, DIC_TEXT_SIZE);
buf1[DIC_TEXT_SIZE-1]=0;					//pro jistotu doplnime nulou!
buf2[DIC_TEXT_SIZE-1]=0;					//pro jistotu doplnime nulou!

//FIXED: pokud jsou TO stringy hebrejske, musime OTOCIT!!!
if(lang_to == 1){
	strrev(buf1);
	strrev(buf2);
}


//POZOR: tabulka musi byt tabulka prislusneho slovniku!
//dle TO tabulky
return(PorovnejRetezce(buf1, buf2,  &razeni[2][0] ));	//dle TO slova, mapa je 512 bytes ZA tim
}

//----------------------------------------------------------


//==========================================================================

//Obecna porovnavaci funkce pro dva stringy.
//IN: 	pointer na string a,
//		pointer na string b,
//		pointer na PRISLUSNOU radici tabulku (256 dvojic).Tabulka obsahuje na 1.miste ASCII
//		hodnotu. Na druhem miste 0 pro NEsprezky, jinak druhou ASCII hodnotu. Tabulka konci dvema
//		nulami.
//OUT:	(-1)	a<b
//	  	(0)		a=b
//		(+1)	a>b
//POZOR: Sprezka NESMI mit druhy znak nulovy! Pak to NENI jako sprezka!
//ODSTRANEN BUG: obe pole uz NEMUSI za ukoncovaci \0 mit jeste alespon dve NULY. Pak to smeti
//v bufferu za \0 bralo jako dalsi znaky.
//FIXED: zaveden test ve while cyklech na konec bufferu. Pokud byly dva stejne stringy, ktere mely
//pred \0 napr. mezeru (neco co neni v tabulce), tak to preslo za \0 a pak bylo poradi dano
//NAHODNYMI znaky za \0. Opraveno.

//POZOR! -------  odlisnosti D2.4 a D3 ----------
//DODELANO: Pokud najdeme hit v zakladni radici tabulce, jdeme jeste do "mapy", ktera je o 512 (!!!)bytes (1024 bytes BYLO v D2.4)
//dale. Pokud ma znak "bratricky", tak dojedeme az do posledniho.
//POZOR: To cele pracuje na zaklade toho, ze mapa SDRUZUJE OBLASTI ZAKLADNI TABULKY, KTERE JSOU
//VEDLE SEBE!! Jinak bychom nemohli porovnavat vysledne indexy z mapy!!!!!!!
//POkud je v mape 1, pak nasledujici znak si je s danym roven. Pokud je 0, pak ukoncime hledani
//stejnych znaku

//DODELANO: Fixed pripad napr. bet s vokalem (neni v tabulce) a bet s alefem. Znak, ktery mel
//hit je delsi, za bet s vokelam uz neni hit, je tudiz kratsi!


signed int PorovnejRetezce(unsigned char *a, unsigned char *b, unsigned char *tab)
{
BOOL	fa, fb;			//flags, TRUE=nalezen hit v tabulce
register int	ta;
register int	tb;			//ukazatele na pozici v tabulce (PRVNI ze dvou bajtu)
int		pa, pb;			//ukazatele na pozice v bufferech.

pa=0;
pb=0;

while(a[pa]!=0 && b[pb]!=0){					//az do konce kratsiho bufferu
	fa=FALSE;
	fb=FALSE;
//najdeme prvni hit pro buffer a
//FIXED: do podminky while pridana moznost, ze string konci pred \0 znaky, ktere nejsou v tabulce
	while(fa!=TRUE && a[pa]!=0){					//dokud neni hit nebo konec bufferu
		//hledame DVOUSTUPNOVE, nejdrive sprezky
		ta=0;
		while(!(tab[ta]==0 && tab[ta+1]==0)){	//az do konce tabulky
			if(a[pa]==tab[ta]){				//shoda 1. znaku
				if((a[pa+1]==tab[ta+1]) && (a[pa+1]!=0)){	//shoda ve sprezce, SPREZKA ALE NEMA DRUHY ZNAK NULOVY!
					pa++;					//posun ukazatel, byla sprezka
					fa=TRUE;				//nahod flag

					//DODELANO:ted se podivame, jestli nalezeny znak nema brachy v mape.
					//Pokud ano, dojedeme az k poslednimu.
					while(tab[ta+512]!=0)		//D2.4 mel 1024
						ta+=2;

					break;					//ta/2 udava nalezenou pozici
				}
			}
			ta+=2;							//POZOR, posun na dalsi dvojici v tabulce
		}
		//pokud fa!=TRUE, pak nebyla nalezena sprezka a hledame single znak-do prvniho vyskytu
		if(!fa){
			ta=0;
			while(!(tab[ta]==0 && tab[ta+1]==0)){	//az do konce tabulky, pri hitu break
				if(a[pa]==tab[ta]){				//shoda 1. znaku-TED UZ STACI, NEMUZE BYT SPREZKA
					fa=TRUE;				//nahod flag

					//DODELANO:ted se podivame, jestli nalezeny znak nema brachy v mape.
					//Pokud ano, dojedeme az k poslednimu.
					while(tab[ta+512]!=0)		//D2.4 mel 1024
						ta+=2;


					break;					//ta/2 udava nalezenou pozici
				}
				ta+=2;						//POZOR, posun na dalsi dvojici v tabulce
			}
		}
	pa++;									//pa ukazuje na DALSI (testovanou) pozici
	}

//najdeme prvni hit pro buffer b
//FIXED: do podminky while pridana moznost, ze string konci pred \0 znaky, ktere nejsou v tabulce
	while(fb!=TRUE && b[pb]!=0 ){			//dokud neni hit nebo konec bufferu
		//hledame DVOUSTUPNOVE, nejdrive sprezky
		tb=0;
		while(!(tab[tb]==0 && tab[tb+1]==0)){	//az do konce tabulky
			if(b[pb]==tab[tb]){				//shoda 1. znaku
				if((b[pb+1]==tab[tb+1]) && (b[pb+1]!=0)){		//shoda ve sprezce
					pb++;					//posun ukazatel, byla sprezka
					fb=TRUE;				//nahod flag

					//DODELANO:ted se podivame, jestli nalezeny znak nema brachy v mape.
					//Pokud ano, dojedeme az k poslednimu.
					while(tab[tb+512]!=0)	//D2.4 mel 1024
						tb+=2;


					break;					//tb/2 udava nalezenou pozici
				}
			}
			tb+=2;							//POZOR, posun na dalsi dvojici v tabulce
		}
		//pokud fa!=TRUE, pak nebyla nalezena sprezka a hledame single znak-do prvniho vyskytu
		if(!fb){
			tb=0;
			while(!(tab[tb]==0 && tab[tb+1]==0)){	//az do konce tabulky, pri hitu break
				if(b[pb]==tab[tb]){				//shoda 1. znaku-TED UZ STACI, NEMUZE BYT SPREZKA
					fb=TRUE;				//nahod flag

					//DODELANO:ted se podivame, jestli nalezeny znak nema brachy v mape.
					//Pokud ano, dojedeme az k poslednimu.
					while(tab[tb+512]!=0)	//D2.4 mel 1024
						tb+=2;


					break;					//tb/2 udava nalezenou pozici
				}
				tb+=2;						//POZOR, posun na dalsi dvojici v tabulce
			}
		}
	pb++;									//pb ukazuje na DALSI (testovanou) pozici
	}
	//pokud je fa && fb TRUE, pak byly hity a je co porovnat
	if(fa==TRUE && fb==TRUE){				//mame hity z obou bufferu, porovname
		ta=ta>>1;							//ted spocitame pozice, od 0
		tb=tb>>1;

		if(ta<tb)
			return -1;						//a<b
		if(ta>tb)
			return	1;						//a>b
	}
	//DODELANO: BUG: bez tohoto to spatne rozlisilo napr. bet s vokalem a bet s alefem!
	else{//alespon jeden z bufferu nemel hit. Ten ktery mel hit je DELSI(=VETSI)!!
		if(fa==TRUE && fb!=TRUE){			//a melo hit, je delsi!
			return	1;						//a>b
		}
		if(fa!=TRUE && fb==TRUE){			//b melo hit, je delsi!
			return -1;						//a<b
		}
	}
	////////////

	//pokud se dostane sem, byly stringy stejne a udelame dalsi kolo
}
//pokud je to tady, stringy jsou bud totozne(a stejne dlouhe) nebo je jeden
//kratsi, ale spolecna delka byla stejna

if(a[pa]==0 && b[pb]!=0)					//string b jeste neco obsahuje, je delsi!
	return	-1;

if(a[pa]!=0 && b[pb]==0)					//string a jeste neco obsahuje, je delsi!
	return	1;

//posledni moznost-stringy jsou stejne

return 0;

}
//==========================================================================

