/*
 
mDavar 2.0 - Simple Hebrew dictionary for J2ME
Copyright (C) 2007 Josef Planeta <freedavar@centrum.cz>
Copyright (C) 2007 Vladimir Marcenko <vladimir-2@rambler.ru>

 
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 
*/
 
 
import java.io.IOException;

import javax.microedition.lcdui.*; 
import javax.microedition.midlet.MIDletStateChangeException;

// definice nov tdy, potomka tdy Canvas 
public class DictCZ extends Canvas implements CommandListener{ 


	String		s, s2;
//	Font		font;
	int			l, r,f,i;
	int			flag;						//pro prvni cteni bude synchronizovane, pak uz ne!
	
	Form 		search_cz;
	TextField	tf;
	int			tf_index;


    Command searchCommand = new Command("Search[5]", Command.SCREEN, 1);

    Command oppositeCommand = new Command("Opposite[0]", Command.SCREEN, 1);
    Command optionsCommand = new Command("Options", Command.SCREEN,  2);
	Command aboutCommand = new Command("About",  Command.SCREEN, 3);
    Command exitCommand = new Command("Exit",  Command.SCREEN, 4);
	
	
	Command backCommand = new Command("Back", Command.SCREEN, 1);
	Command OKCommand = new Command("OK", Command.SCREEN, 1);
	
    //constructor - add commands
    public DictCZ(){
    	
        addCommand(searchCommand);
        addCommand(oppositeCommand);
        addCommand(optionsCommand);
        addCommand(aboutCommand);
        addCommand(exitCommand);
        
        setCommandListener(this);
    }
    

	public void paint(Graphics g) { 
		
		int			counter=0;		//counter of records, will determine first record in do{} cycle
		int			flag=0;			//if set to1 : we got exception (no next file)


		
		mDavar.g_font = Options.getFont();	//Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_MEDIUM) ;
		mDavar.DISPLAY_SIZE_X=getWidth();
		mDavar.DISPLAY_SIZE_Y=getHeight();

			
		g.setFont(mDavar.g_font);

		g.setColor(Options.options[8]);			//0, 255, 0);
	  	g.fillRect(0, 0, getWidth(), getHeight());

 		g.setColor(0, 0, 0);		//black text

        g.setClip(0, 0, getWidth(), getHeight());
        Point end = new Point(0, 0);        
      

        
        do {            

        	if(counter == 0){
        		//now store offset+file of first record
        		mDavar.mdd.data_offset_first = mDavar.mdd.data_offset;
        		mDavar.mdd.data_file_first = mDavar.mdd.data_file;
        	}
        	
        	
        	try{
    			mDavar.mdd.ReadRecord(MDD.direction, mDavar.mdd.data_file, mDavar.mdd.data_offset, 0);
        	} catch (IOException e) 
        	{
        		flag = 1;
        	}	

        	counter++;			 
        	

        	end = TextGraphics.drawTranslationText(mDavar.mdd.data_from, mDavar.mdd.data_from_size, g, end);
            end = TextGraphics.drawHebrewText(mDavar.mdd.data_to, mDavar.mdd.data_to_size, g, end);

        	
        	int fontHeight = g.getFont().getHeight();
            end.y+= (fontHeight > TextGraphics.HE_CHARS_HEIGHT) ? fontHeight: TextGraphics.HE_CHARS_HEIGHT;
            end.x = 0;

            
        } while( (end.y < (getHeight() - TextGraphics.HE_CHARS_HEIGHT)) && flag != 1); // Maybe also consider translation font size!        

 		
 		
 		
	} //paint()

//-----------------------------------------------------------------------------------

public void ShowSearchCZ() {

		int			f;
		
		//nulujeme hledany cz string
		for(f=0; f < mDavar.KEY_SIZE_MAX; f++)
			mDavar.key_CZ[f]=0;

		//jeho delka je 0
		mDavar.key_size_CZ=0;

		
		search_cz = new Form("Insert word");
		
		tf = new TextField("","",mDavar.KEY_SIZE_MAX,0);		//textfield, sem zadavame hledany CZ string
		tf_index = search_cz.append(tf);
        
        search_cz.addCommand(OKCommand);
        search_cz.setCommandListener(this);
        mDavar.display.setCurrent(search_cz);
    }
	
//-----------------------------------------------------------------------------------	

    //user keep klavesu
    protected void keyRepeated(int key){
        keyPressed(key);
    }
  
    
    //user pressed key
	protected void keyPressed(int key){
			if(	key == Canvas.KEY_NUM6 ||
				getGameAction(key) == Canvas.RIGHT){ //PgDown
                ScrollPageDown();
			}

			if(	key == Canvas.KEY_NUM4 ||
				getGameAction(key) == Canvas.LEFT){ //PgUp
	    		ScrollPageUp();
			}

			if( key == Canvas.KEY_NUM2 ||
				getGameAction(key) == Canvas.UP){ //LnUp
	    		ScrollLineUp();
			}

			if(	key == Canvas.KEY_NUM8 ||
				getGameAction(key) == Canvas.DOWN){ //LnDown
	    		ScrollLineDown();
			}
	
			if(	key == Canvas.KEY_NUM5 || getGameAction(key) == Canvas.FIRE){ //Zadani slova pro hledani
				ShowSearchCZ();		//form enter latin based key +search 
			}

            //0=Opposite direction
			if(	key == Canvas.KEY_NUM0){ 			//turn 
				mDavar.OppositeDirection();
            }
			
			
	}

	public void commandAction(Command c, Displayable d) {
        if(c == oppositeCommand)
            keyPressed(Canvas.KEY_NUM0);
        
        else if(c == searchCommand)
            keyPressed(Canvas.KEY_NUM5);        
        
        else if(c == exitCommand){
        	try{
        		mDavar.instance.destroyApp(true);
        	}catch (MIDletStateChangeException e) {}
        }
        	
        
        else if(c == aboutCommand) 
            mDavar.dict_he.showAbout();
        
        else if(c == backCommand)
            mDavar.display.setCurrent(this);
        
        else if(c == optionsCommand)
        	mDavar.ShowOptions();
       
        else if(c == OKCommand){
        	
        	//read key
            s=tf.getString();	  //zatim do s - stringu

            for(f=0; f< tf.size(); f++){
              mDavar.key_CZ[f]=s.charAt(f);
            }
			
			//key size
			mDavar.key_size_CZ=tf.size();
			
			Search.SearchCZ();
			
			
			//now perform search

//			mDavar.search.SearchCZ();			//will set data_file and data_offset
			mDavar.ShowDictCZCanvas();

			//hledani, ktere nalezne offset_index
//            MainClass.offset_index=MainClass.HledejCZ();
//System.out.println("KEY=" + s + '\n');
//mDavar.display.setCurrent(this);
			
        }
        
	
	}
        
        
        //SCROLL SLOVNIKU O STRANKU DOLU -------------//
        public void ScrollPageDown(){
		int		off;

//DEBUG:
//System.out.println("Before scroll page: off=" + mDavar.mdd.data_offset + " file=" + mDavar.mdd.data_file + '\n');

		//just repaint will use final record offset as base for new page offsets
		repaint();

	}


	//SCROLL SLOVNIKU O STRANKU NAHORU -------------//
	public void ScrollPageUp(){
		
		try{
			f = mDavar.mdd.FindPreviousPageRecord(mDavar.mdd.direction, mDavar.mdd.data_file_first, mDavar.mdd.data_offset_first);
		} catch (IOException e) {}	

		if(f == 0)		//repaint only if no error - scroll up can reach top!
			repaint();

	}


	//SCROLL SLOVNIKU O RADEK NAHORU -------------//
	public void ScrollLineUp(){
		try{
			f = mDavar.mdd.FindPreviousRecord(mDavar.mdd.direction, mDavar.mdd.data_file_first, mDavar.mdd.data_offset_first);
		} catch (IOException e) {}	

		if(f == 0)		//repaint only if no error - scroll up can reach top!
			repaint();

	}



	//SCROLL SLOVNIKU O RADEK DOLU -------------//
	public void ScrollLineDown(){

		//we will search from first record forward for nex one and display
//DEBUG:
//System.out.println("Before FindNextRecord: off=" + mDavar.mdd.data_offset_first + " file=" + mDavar.mdd.data_file_first);

		try{
			mDavar.mdd.FindNextRecord(mDavar.mdd.direction, mDavar.mdd.data_file_first, mDavar.mdd.data_offset_first);
		} catch (IOException e) {}	

//DEBUG:
//System.out.println("After FindNextRecord: off=" + mDavar.mdd.data_offset + " file=" + mDavar.mdd.data_file + '\n');
		
		repaint();


		
	}


	



} 
