/*
 
mDavar 2.0 - Simple Hebrew dictionary for J2ME
Copyright (C) 2007 Josef Planeta <freedavar@centrum.cz>
Copyright (C) 2007 Vladimir Marcenko <vladimir-2@rambler.ru>

 
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 
*/

import java.io.IOException;

import javax.microedition.lcdui.*; 
import javax.microedition.midlet.MIDletStateChangeException;

 
public class DictHE extends Canvas implements CommandListener{ 


	String		s, s2;
//	Font		font;
	int			l, r,f,i;
	int 		startIndex, endIndex;
	int			flag;						//pro prvni cteni bude synchronizovane, pak uz ne!
	

    Command searchCommand = new Command("Search[5]", Command.SCREEN, 1);

    Command oppositeCommand = new Command("Opposite[0]", Command.SCREEN, 1);
    Command optionsCommand = new Command("Options", Command.SCREEN,  2);
	Command aboutCommand = new Command("About",  Command.SCREEN, 3);
    Command exitCommand = new Command("Exit",  Command.SCREEN, 4);
	
	Command backCommand = new Command("Back", Command.BACK, 1);
	
    //constructor - add commands
    public DictHE(){
    	
        addCommand(searchCommand);
        addCommand(oppositeCommand);
        addCommand(optionsCommand);
        addCommand(aboutCommand);
    	addCommand(exitCommand);
        
        setCommandListener(this);
    }
    
    
    
	public void paint(Graphics g) { 
		
		int			counter=0;		//counter of records, will determine first record in do{} cycle
		int			flag=0;			//if set to1 : we got exception (no next file)

		mDavar.g_font = Options.getFont();	//Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_SMALL);//MEDIUM) ;
		mDavar.DISPLAY_SIZE_X=getWidth();
		mDavar.DISPLAY_SIZE_Y=getHeight();

			
		g.setFont(mDavar.g_font);

  		g.setColor(Options.options[8]);//			0, 255, 0);
	  	g.fillRect(0, 0, getWidth(), getHeight());

 		g.setColor(0, 0, 0);		//black text

        g.setClip(0, 0, getWidth(), getHeight());
        Point end = new Point(0, 0);        


      

        
        do {            

        	if(counter == 0){
        		//now store offset+file of first record
        		mDavar.mdd.data_offset_first = mDavar.mdd.data_offset;
        		mDavar.mdd.data_file_first = mDavar.mdd.data_file;
        	}
        	
        	
        	try{
    			mDavar.mdd.ReadRecord(mDavar.mdd.direction, mDavar.mdd.data_file, mDavar.mdd.data_offset, 0);
        	} catch (IOException e) 
        	{
        		flag = 1;
        	}	

        	counter++;			 
        	

        	end = TextGraphics.drawHebrewText(mDavar.mdd.data_from, mDavar.mdd.data_from_size, g, end);
            end = TextGraphics.drawTranslationText(mDavar.mdd.data_to, mDavar.mdd.data_to_size, g, end);

        	
        	int fontHeight = g.getFont().getHeight();
            end.y+= (fontHeight > TextGraphics.HE_CHARS_HEIGHT) ? fontHeight: TextGraphics.HE_CHARS_HEIGHT;
            end.x = 0;

            
        } while( (end.y < (getHeight() - TextGraphics.HE_CHARS_HEIGHT)) && flag != 1); // Maybe also consider translation font size!        
 		
	} //paint()


	
    //user keep key
    protected void keyRepeated(int key){
        keyPressed(key);
    }
  
    
    //user pressed key
	protected void keyPressed(int key){
			if(	key == Canvas.KEY_NUM6 ||
				getGameAction(key) == Canvas.RIGHT){ //PgDown
                ScrollPageDown();
			}

			if(	key == Canvas.KEY_NUM4 ||
				getGameAction(key) == Canvas.LEFT){ //PgUp
	    		ScrollPageUp();
			}

			if( key == Canvas.KEY_NUM2 ||
				getGameAction(key) == Canvas.UP){ //LnUp
	    		ScrollLineUp();
			}

			if(	key == Canvas.KEY_NUM8 ||
				getGameAction(key) == Canvas.DOWN){ //LnDown
	    		ScrollLineDown();
			}
	
			if(	key == Canvas.KEY_NUM5 || getGameAction(key) == Canvas.FIRE){ //Zadani slova pro hledani
				mDavar.ShowSearchHebrew();		//dialog edit HE key+search 
			}

            //0=Opposite direction
			if(	key == Canvas.KEY_NUM0){ 			//turn 
				mDavar.OppositeDirection();
            }

	}

    public void commandAction(Command c, Displayable d) {
        if(c == oppositeCommand)
            keyPressed(Canvas.KEY_NUM0);
        
        else if(c == searchCommand)
            keyPressed(Canvas.KEY_NUM5);        
        
        else if(c == exitCommand){
        	try{
        		mDavar.instance.destroyApp(true);
        	}catch (MIDletStateChangeException e) {}
        }
        	
        else if(c == aboutCommand) 
            showAbout();
        
        else if(c == optionsCommand)
        	mDavar.ShowOptions();

        
        else if(c == backCommand){
        	//we will return to HE-CZ or CZ-HE canvas, according direction
        	if(MDD.direction == 0)
        		mDavar.display.setCurrent(mDavar.dict_he);
        	else
        		mDavar.display.setCurrent(mDavar.dict_cz);
        }
        
        else if(c == optionsCommand)
            ;//mDavar.display.setCurrent(mDavar.options);
    }    
  

//----------------------------------------------------------------//

     public void showAbout() {

    	Form 		about = new Form("");	//About mDavar is better to NOT display-on phones with small display
        String		s, s2 = "";
        
        try{
        	about.append(Image.createImage("/splash.png"));
        }catch (IOException e) {}

        
        s = 
        "mDavar 2.0\n" +
        "Authors: Josef Planeta & Vladimir Marchenko.\n" +
        "For info visit: www.davar3.com  \n" +
        "Actual dictionary: \n";
   


        //info string according direction
        if(MDD.direction == 0)
        	s2 = "[" + MDD.words + " words] " + MDD.label_from;
        else
        	s2 = "[" + MDD.words + " words] " + MDD.label_to;
        
        
        StringItem item = new StringItem("",s+s2);
        
        about.append(item);

        
        
        Ticker t = new Ticker(s+s2);
        about.setTicker(t);      

        
        
        about.addCommand(backCommand);
        about.setCommandListener(this);
        mDavar.display.setCurrent(about);
    }
    
    
     //------------------------------------------------------
     
     //SCROLL SLOVNIKU O STRANKU DOLU -------------//
	public void ScrollPageDown(){
		int		off;

		//DEBUG:
		//System.out.println("Before scroll page: off=" + mDavar.mdd.data_offset + " file=" + mDavar.mdd.data_file + '\n');

		//just repaint will use final record offset as base for new page offsets
		repaint();
	}


	//SCROLL SLOVNIKU O STRANKU NAHORU -------------//
	public void ScrollPageUp(){
		
		try{
			f = mDavar.mdd.FindPreviousPageRecord(mDavar.mdd.direction, mDavar.mdd.data_file_first, mDavar.mdd.data_offset_first);
		} catch (IOException e) {}	

		if(f == 0)		//repaint only if no error - scroll up can reach top!
			repaint();

	}


	//SCROLL SLOVNIKU O RADEK NAHORU -------------//
	public void ScrollLineUp(){
		try{
			f = mDavar.mdd.FindPreviousRecord(mDavar.mdd.direction, mDavar.mdd.data_file_first, mDavar.mdd.data_offset_first);
		} catch (IOException e) {}	

		if(f == 0)		//repaint only if no error - scroll up can reach top!
			repaint();

	}



	//SCROLL SLOVNIKU O RADEK DOLU -------------//
	public void ScrollLineDown(){

		//we will search from first record forward for nex one and display
//DEBUG:
//System.out.println("Before FindNextRecord: off=" + mDavar.mdd.data_offset_first + " file=" + mDavar.mdd.data_file_first);

		try{
			mDavar.mdd.FindNextRecord(mDavar.mdd.direction, mDavar.mdd.data_file_first, mDavar.mdd.data_offset_first);
		} catch (IOException e) {}	

//DEBUG:
//System.out.println("After FindNextRecord: off=" + mDavar.mdd.data_offset + " file=" + mDavar.mdd.data_file + '\n');
		
		repaint();


		
	}






} 
