/*
 
mDavar 2.0 - Simple Hebrew dictionary for J2ME
Copyright (C) 2007 Josef Planeta <freedavar@centrum.cz>
Copyright (C) 2007 Vladimir Marcenko <vladimir-2@rambler.ru>

 
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 
*/


import java.io.*;



public class MDD {
       
	public static final int DATA_FILE_LEN = 	4096;	//max length of data file
	public static final int OFF_TAB = 64;	  			//sorting table offset in mdd
	public static final int DATA_FROM_SIZE = 	128;	//size of from buffer
	public static final int DATA_TO_SIZE = 	128;		//size of to buffer


	public static int				words;						//# of words in opened dictionary
	public static int				key_length;					//length of keyword in index files
	public static int				direction = 0;				//actual direction 0=FROM -> TO (HE->CZ), 1=TO -> FROM (CZ->HE)
	
	public static int				files_from;					//# of files in direction FROM 
	public static int				files_to;					//# of files in direction TO
	
	public static String 			label_from = "";			//label from dictionary    
    public static String 			label_to = "";				//label to dictionary

	public static byte[][]		key_from;					
	public static byte[][]		key_to;						
    public	static byte[] 			flag_from;					//array of flags-read also previous file FROM
    public	static byte[] 			flag_to;					//array of flags-read also previous file TO

    public byte[]					data_from = new byte [DATA_FROM_SIZE]; 
    public byte[]					data_to = new byte [DATA_TO_SIZE];
    public int						data_from_size; 			//actual size of data FROM
    public int						data_to_size;				//actual size of data TO

    public int						data_available[]={0,0};		//[0]HE->CZ, [1]CZ->HE data are presented (1) or missing (0)
    
    
    public DataInputStream 			input = null;				//opened indexes and data files
    public int 					data_offset=0;				//offset of actual file
    public int 					data_file=1;				//number of actual file, ONEBASED!

    //offset+file of first record on page:
    public static int 				data_offset_first=0;		
    public static int 				data_file_first=1;		

    
    //buffer for one record
	public byte[]					buf_record = new byte [DATA_FILE_LEN+1];
	

    //    private	 String 			s;
    private int							f, g, i;

        
    



//rows=4, columns=256. Array of sorting, CZ(==latin based lang) part is overwritten from MDD file
//sorting[0][256]:   1. int CZ 1. char - Davar coding
//                   2. int CZ 2. char for double chars (as 'ch') or 0 for single
//sorting[1][256]:   1. int HE according HebrewUniversal coding from Davar
//                   2. int 0
//sorting[2][256]:   1. int map of CZ chars (0,1). 1=NEXT char in table is same weight for comparison, 0=different
//                   2. int UNICODE 1. CZ char. Pokud byla sprezka, je 0. Uz je osetreno v MDD tab souboru
//sorting[3][256]:   1. int map of HE char
//                   2. int 0

    public static int	sorting[][]={	//ABECEDNI poradi znaku. 
  					//V kazdem poli byt ALESPON na poslednim miste 0 0!
  					//Normalni znaky: 'a' 0, 'b' 0, 'c' 0, ....
   					//Sprezky:        ... 'C''h', 'c''h', 'i' 0, .....
  					//POZOR: sprezka MESMI!!! mit druhy znak \0!

  				{	'A', 0 ,'a', 0 ,193, 0 ,225, 0 ,'B', 0 ,'b', 0 ,'C', 0 ,'c', 0 ,//CESKE RAZENI, odpovida typslovniku=0
  					200, 0 ,232, 0 ,'D', 0 ,'d', 0 ,207, 0 ,239, 0 ,'E', 0 ,'e', 0 ,
  					201, 0 ,233, 0 ,204, 0 ,236, 0 ,'F', 0 ,'f', 0 ,'G', 0 ,'g', 0 ,
  					'H', 0 ,'h', 0 ,'C','h','c','h','I', 0 ,'i', 0 ,205, 0 ,237, 0 ,
  					'J', 0 ,'j', 0 ,'K', 0 ,'k', 0 ,'L', 0 ,'l', 0 ,'M', 0 ,'m', 0 ,
  					'N', 0 ,'n', 0 ,210, 0 ,242, 0 ,'O', 0 ,'o', 0 ,211, 0 ,243, 0 ,
  					'P', 0 ,'p', 0 ,'Q', 0 ,'q', 0 ,'R', 0 ,'r', 0 ,216, 0 ,248, 0 ,
  					'S', 0 ,'s', 0 ,138, 0 ,154, 0 ,'T', 0 ,'t', 0 ,141, 0 ,157, 0 ,
  					'U', 0 ,'u', 0 ,218, 0 ,250, 0 ,217, 0 ,249, 0 ,'V', 0 ,'v', 0 ,
  					'W', 0 ,'w', 0 ,'X', 0 ,'x', 0 ,'Y', 0 ,'y', 0 ,221, 0 ,253, 0 ,
  					'Z', 0 ,'z', 0 ,142, 0 ,158, 0 ,'0', 0 ,'1', 0 ,'2', 0 ,'3', 0 , //cislice ZA pismeny
  					'4', 0 ,'5', 0 ,'6', 0 ,'7', 0 ,'8', 0 ,'9', 0 , 0 , 0 , 0 , 0 ,
  					 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
  					 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
  					 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
  					 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0  },
  					 

  					//hebrejske razeni.
  				{	'0', 0 ,'1', 0 ,'2', 0 ,'3', 0 ,'4', 0 ,'5', 0 ,'6', 0 ,'7', 0 ,// 7//
  					'8', 0 ,'9', 0 , 64, 0 , 99, 0 , 65, 0 ,100, 0 , 66, 0 ,101, 0 ,//15////hebrejske KVADRATY, nejdrive NETVRZENE, pak s dagesem
  					 67, 0 ,102, 0 , 68, 0 ,103, 0 , 69, 0 , 93, 0 ,104, 0 , 70, 0 ,//23
  					105, 0 , 71, 0 ,106, 0 , 72, 0 ,107, 0 , 73, 0 ,108, 0 , 74, 0 ,//31////74=konc."ch",94=ch s teckou, 95 s a, 96 s sva, 75=nekoncove ch
  					 94, 0 , 95, 0 , 96, 0 , 75, 0 ,109, 0 , 76, 0 ,110, 0 , 77, 0 ,//39//109=nekoncove k s dagesem,
  					 78, 0 ,111, 0 , 79, 0 , 80, 0 ,112, 0 , 81, 0 ,113, 0 , 82, 0 ,//47//
  					114, 0 , 83, 0 , 84, 0 ,115, 0 , 85, 0 , 86, 0 ,116, 0 , 87, 0 ,//55//
  					117, 0 , 88, 0 ,118, 0 , 89, 0 , 119, 0 ,92, 0 ,122, 0 , 91, 0 ,//63////89=sin, 119=sin s dag., 92=sin+t.vlevo,, 122=sin+t.vlevo+dag,91=sin s t. vpravo,
  					121, 0 , 90, 0 ,120, 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,//71//121=sin s t. vpravo a dagesem,
  				   	 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
  					 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
  					 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
  					 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
  					 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
  					 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
  					 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 	},

  					//zde nasleduji "mapy" stejnych znaku, tj. tech, ktere jsou si rovny.
  					//Protoze v "hlavni" radici tabulce jsou uz znaky serazeny, ukolem mapy
  					//je oznacit, ZE NASLEDUJICI znak (v hlavni tabulce) si je s timto rovny (=1),
  					//nebo nerovny (=0)
  					//druhy int je UNICODE 1. CZ znaku

  					//mapy ceskeho razeni. DIAKRITIKA SE IGNORUJE!

  				{	1,  'A', 1 ,'a', 1 ,193, 0 ,225, 1 ,'B', 0 ,'b', 1 ,'C', 1 ,'c',//CESKE RAZENI, odpovida typslovniku=0
  					1,  268, 0 ,269, 1 ,'D', 1 ,'d', 1 ,270, 0 ,271, 1 ,'E', 1 ,'e',
  					1,  201, 1 ,233, 1 ,282, 0 ,283, 1 ,'F', 0 ,'f', 1 ,'G', 0 ,'g',
  					1,  'H', 0 ,'h', 1 , 0 , 0 , 0 , 1, 'I', 1 ,'i', 1 ,205, 0 ,237, //bylo Ch a ch
  					1,  'J', 0 ,'j', 1 ,'K', 0 ,'k', 1 ,'L', 0 ,'l', 1 ,'M', 0 ,'m',
  					1,  'N', 1 ,'n', 1 ,327, 0 ,328, 1 ,'O', 1 ,'o', 1 ,211, 0 ,243,
  					1,  'P', 0 ,'p', 1 ,'Q', 0 ,'q', 1 ,'R', 1 ,'r', 1 ,344, 0 ,345,
  					1,  'S', 1 ,'s', 1 ,352, 0 ,353, 1 ,'T', 1 ,'t', 1 ,356, 0 ,357,
  					1,  'U', 1 ,'u', 1 ,218, 1 ,250, 1 ,366, 0 ,367, 1 ,'V', 0 ,'v',
  					1,  'W', 0 ,'w', 1 ,'X', 0 ,'x', 1 ,'Y', 1 ,'y', 1 ,221, 0 ,253,
  					1,  'Z', 1 ,'z', 1 ,381, 0 ,382, 1 ,'0', 0 ,'1', 0 ,'2', 0 ,'3', //cislice ZA pismeny
  					0,  '4', 0 ,'5', 0 ,'6', 0 ,'7', 0 ,'8', 0 ,'9', 0 , 0 , 0 , 0 ,
  					0,   0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
  					0,   0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
  					0,   0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
  					0,   0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 	},
  	


  					//mapy hebrejskeho razeni
  				  {   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  					  0,  0,  0,  0,  1,  0,  0,  0,  1,  0,  0,  0,  1,  0,  0,  0,
  				      1,  0,  0,  0,  1,  0,  0,  0,  1,  0,  1,  0,  0,  0,  1,  0,
  					  0,  0,  1,  0,  0,  0,  1,  0,  0,  0,  1,  0,  0,  0,  1,  0,
  					  1,  0,  1,  0,  1,  0,  1,  0,  0,  0,  1,  0,  0,  0,  1,  0,
  					  1,  0,  0,  0,  1,  0,  1,  0,  0,  0,  1,  0,  0,  0,  1,  0,
  				      0,  0,  1,  0,  1,  0,  0,  0,  1,  0,  1,  0,  0,  0,  1,  0,
  					  0,  0,  1,  0,  0,  0,  1,  0,  1,  0,  1,  0,  1,  0,  1,  0,
  					  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  					  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  					  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  					  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  					  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  					  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  					  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  					  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 }};
    


//INDEX file format: index(HE->CZ) and indexi(CZ->HE)

/*
| offset|    |                                                                |
|       |    |                                                                |
|     0 |  40| Name of dictionary, unused = 0. Last char (offset 39) is 0     |
|    40 |   4| Number of all files for direction of index                     |
|    44 |   4| Number of all words                                            |
|    48 |   1| Length of keyword (INDEX_LENGTH) default value is 8            |
|    49 |    | unused bytes filled by 0                                       |

|  1024 |    |DATA AREA. Structure of data:                                   |
|       |    |INDEX_LENGTH bytes of keyword for file 0001. Unused bytes are 0 |
|       |    |1 byte flag: 0 when previous file, last record has DIFFERENT    |
|       |    |word, 1 when has EXACTLY same word                              |
|       |    |                                                                |
|       |    |INDEX_LENGTH bytes of keyword for file 0002. Unused bytes are 0 |
|       |    |1 byte flag: 0 when previous file, last record has DIFFERENT    |
|       |    |word, 1 when has EXACTLY same word                              |
|       |    |                                                                |
|       |    |...etc for all files of same direction                          |


*/
        
// --------------------------------------------------------------------------------
   //test in index file is available, return 1 if yes, 0 if no
    
    public int TestIndexFrom(){
    	
    	DataInputStream 	input;
   	

    	try{
    		    		
    		input = new DataInputStream(getClass().getResourceAsStream("index"));	//index
	        input.readUnsignedByte();
	    	input.close();

    	} 
    	catch (EOFException e) {
    		return 0;
    	}
    	
    	catch (IOException e) {
    		return 0;
    	}
    	
    	catch(NullPointerException DataInputStream) {
    		return 0;
    	}
    	
    	
    	return 1;
    }
   
// --------------------------------------------------------------------------------
   //test in indexi file is available, return 1 if yes, 0 if no
    
    public int TestIndexTo(){
    	
    	DataInputStream 	input;
   	

    	try{
    		    		
    		input = new DataInputStream(getClass().getResourceAsStream("indexi"));	//indexi
	        input.readUnsignedByte();
	    	input.close();

    	} 
    	catch (EOFException e) {
    		return 0;
    	}
    	
    	catch (IOException e) {
    		return 0;
    	}
    	
    	catch(NullPointerException DataInputStream) {
    		return 0;
    	}
    	
    	
    	return 1;
    }
   
    

// --------------------------------------------------------------------------------
    
    public int OpenIndexes() throws IOException {
    	
    	int 				offset = 0;							//offset in index file
        int					f, g;
    	DataInputStream 	input;
 
    	
//index: HE->CZ
    	
    if(data_available[0] == 1){    		    		
		input = new DataInputStream(getClass().getResourceAsStream("index"));	//index
	

    	// label string - 40 bytes
        for(f=0; f<40; f++){
        	label_from += String.valueOf( (char)input.readUnsignedByte());
        }
        offset += 40;
    	
        //number of all files from
        files_from = reverseBytes(input.readInt());
        	
        //number of all words
        words = reverseBytes(input.readInt());

        //length of key in indexes
        key_length = (int)(input.readUnsignedByte());
        
        //SKIP reserved 0x00 bytes
        for(f=49; f<1024; f++){
        	input.readUnsignedByte();
        }

        //now alloc space for key and flag "search in previous file"
        key_from = new byte [files_from][key_length];					//array of keys FROM
        flag_from = new byte [files_from];								//array of flags-read also previous file TO
        
        //read from stream
        for(f=0; f<files_from; f++){
        	//read key
        	for(g=0; g<key_length; g++){
        		key_from[f][g] = (byte)input.readByte();			//changed to int!
            }
        	//read flag
        	flag_from[f] = (byte)input.readByte();				//byte!
        }       
        
        // close data stream
    	input.close();
    }


    	
//indexi: CZ->HE

    if(data_available[1] == 1){    	
    	input = new DataInputStream(getClass().getResourceAsStream("indexi"));	//indexi
    	
    	
        // label string - 40 bytes
        for(f=0; f<40; f++){
        	label_to += String.valueOf( (char)input.readUnsignedByte());
        }
        offset += 40;
    	
        //number of all files from
        files_to = reverseBytes(input.readInt());
        	
        //number of all words, should be same, but we MUST READ!!
        words = reverseBytes(input.readInt());

        //length of key in indexes: SAME, BUT WE MUST READ!!
        key_length = (int)(input.readUnsignedByte());
        
        //SKIP reserved 0x00 bytes
        for(f=49; f<1024; f++){
        	input.readUnsignedByte();
        }

        //now alloc space for key and flag "search in previous file"
        key_to = new byte [files_to][key_length];						//array of keys TO
        flag_to = new byte [files_to];								//array of flags-read also previous file TO
        
        //read from stream
        for(f=0; f<files_to; f++){
        	//read key
        	for(g=0; g<key_length; g++){
        		key_to[f][g] = (byte)input.readByte();			//changed to int!
            }
        	//read flag
        	flag_to[f] = (byte)input.readByte();				//byte!
        }       
        
        // close data stream
    	input.close();
    }
  	
    	
 
    	
/*
//DEBUG: list indexi[][]
String	s;
for(f=0; f<files_to; f++){
	s = "";
	//create string from index - for compare!
	for(g = 0; g<key_length; g++){
		if(key_to[f][g] == 0){	
			continue;
		}
		s=s+(char)key_to[f][g];
	}
	s = Convert2Unicode(s, s.length()); //prekodujeme
	System.out.print(s +", ");
   	if(f % 16 == 0)
  		System.out.println('\n');
}
//DEBUG
*/ 
 	
    	        	
    	return 0;
    }
    
// --------------------------------------------------------------------------------
    
    public int OpenSortTables() throws IOException {
    	

        int					f, g, h;
        int					i,j;		//for test only
    	DataInputStream 	input=null;
    	int 				IN_BUF_SIZE = 1024;     			//buf size
    	byte[]				inBuf = new byte [IN_BUF_SIZE]; 	//


    for(h=0; h<2; h++){

    	if(h == 0){
    		input = new DataInputStream(getClass().getResourceAsStream("sorti"));//TO-CZECH
    	}
    	
    	if(h == 1){
    		input = new DataInputStream(getClass().getResourceAsStream("sort"));//FROM-HEBREW
    	}

    	//read ALL
        for(f=0; f<768; f++){
        	inBuf[f] = (byte)input.readByte();
        }

        // close data stream
    	input.close();

    	
    	 //Nacteme tabulku razeni - od OFF_TAB, 128 polozek, 2+2+2 bajty kazda, nevyuzite
        //data zaplneny nulami. Celkem 768 bytes
        //1. byte: 	unsigned char 1. znak (KODOVANI JAKO V DAVARU)
        //2. byte: 	unsigned char 2. znak POKUD JE SPREZKA, JINAK 0 (KODOVANI JAKO V DAVARU)
        //3.-4 byte: UNICODE hodnota 1. znaku, pokud je sprezka tak 0. Unsigned short
        //5.byte:   unsigned char  mapa (0 nebo 1)
    	//6.byte:   unsigned char  = 0 (reserved)


        //ted data ulozime do sorting[][]
        for(g=0; g<128; g++){
            //1. znak - 0. byte
  			f=0;
			f = (inBuf[6*g]<0)?256+inBuf[6*g]:inBuf[6*g]; //

//if(sorting[0+h][2*g] != f)
//System.out.println("sorting[" +h+"]["+(2*g)+"]=" + sorting[0+h][2*g] +"=>" + f+'\n');

			sorting[0+h][2*g]=f;
            //2. znak - 1.byte
            f=0;
            f = (inBuf[6*g+1]<0)?256+inBuf[6*g+1]:inBuf[6*g+1];

//if(sorting[0+h][2*g+1]!=f)
//System.out.println("sorting[" +h+"]["+(2*g+1)+"]=" + sorting[0+h][2*g+1] +"=>" + f+'\n');

            sorting[0+h][2*g+1]=f;

            //2+3 byte - UNICODE 1. znaku
  			f=0;
			f += (inBuf[6*g+3]<0)?256+inBuf[6*g+3]:inBuf[6*g+3];
       		f *= 256;
			f += (inBuf[6*g+2]<0)?256+inBuf[6*g+2]:inBuf[6*g+2]; 

//if(sorting[2+h][2*g+1]!=f)
//System.out.println("sorting[" +(2+h)+"]["+(2*g+1)+"]=" + sorting[2+h][2*g+1] +"=>" + f+'\n');

			sorting[2+h][2*g+1]=f;

            //4 byte - mapa. 5 byte je 0, necteme jej
  			f=0;
			f = (inBuf[6*g+4]<0)?256+inBuf[6*g+4]:inBuf[6*g+4]; 

//if(sorting[2+h][2*g]!=f)
//System.out.println("sorting[" +(2+h)+"]["+(2*g)+"]=" + sorting[2+h][2*g] +"=>" + f+'\n');
			
			sorting[2+h][2*g]=f;       //mapa
        }    	

    }

    
//DEBUG: list of sorting[][]
//for(i=0; i<4; i++){
//	for(j=0;j<256;j++){
//    	System.out.print(sorting[i][j] +", ");
//       	if(j % 15 == 0)
//       		System.out.println('\n');
//	}
//}
//DEBUG	
    
    
    
    return 0;
    }
    
    
    
//-------------------------------------------------------------------------

    
    
    
    //read one record
    //IN: 	direction requested: 0=FROM(HE->CZ), 1=TO(CZ->HE)
    //		file: onebased # of file, where starts search
    //		offset: zerobased offset in file from which start to read
    //		sync: 0=read data immediatelly from offset, 1=search for sync 0x01 first and then read!
    
    //OUT:	0=OK, 1=was red also from NEXT file. Update data_file+data_offset static variables of MDD class
    


	public int	ReadRecord(int dir, int file, int offset, int sync)throws IOException{

		String 			s = "";
		int				ret_val=0;			//return value

		//int				f;
		//String 		s2 = "";
		//byte			b;
		
				
		//first check if we have opened file in good direction and actual offset <= requested offset 
		if(	(dir != direction) ||
			(file != data_file) ||
			(offset < data_offset) ||
			(input == null))			{

			
			try{        					//we must reopen file
				if(input != null){
					input.close();
				}
			} catch (IOException e) {}
	    
	   		//create new string with name of file
	   		s = String.valueOf(file);
	   		if(dir == 0){
	   			s = "0000" + s;					//he->cz file
	   			s = s.substring(s.length()-4, s.length());
	   		}
	   		else{								//cz->he file
	   			s = "0000" + s + "i";			//i means "inversed"
	   			s = s.substring(s.length()-5, s.length());	   			
	   		}
	   		
	   		
	   		//now open requested file
			input = new DataInputStream(getClass().getResourceAsStream(s));
			data_offset = 0;
			
			//now skip bytes to requested offset
			while(data_offset < offset && data_offset < DATA_FILE_LEN){
				input.readByte();
				data_offset++;
			}
		}
		
			if(sync == 1){
				//now we can read until get 01 as start of key FROM
				while(input.readByte()!= 0x01){
					data_offset++;
					if(data_offset >= (DATA_FILE_LEN) ){	//BUG: was (DATA_FILE_LEN-1)
						//continue in next file from offset 0
						ContinueInNextRecord(dir, data_file, files_from);
						ret_val = 1; 
					}
				}
				
				data_offset++;	//we are AFTER 0x01, was missing!				
			}

			
			//now can read key until 02
			data_from_size = 0;
			while(true){
				data_from[data_from_size] = input.readByte();
				data_offset++;

				if(data_offset >= (DATA_FILE_LEN)){			//BUG: was (DATA_FILE_LEN-1)
					//continue in next file from offset 0
					ContinueInNextRecord(dir, data_file, (dir==0)?files_from:files_to);
					ret_val = 1; 
				}
			
				
				if(data_from[data_from_size] == 0x02){
					data_from[data_from_size] = 0;
					data_from_size++;				//now it is length, not index
					break;
				}

				data_from_size++;
			}

			//now can read key until 01
			data_to_size=0;
			while(true){
				data_to[data_to_size] = input.readByte();
				data_offset++;

				if(data_offset >= (DATA_FILE_LEN)){			//BUG: was (DATA_FILE_LEN-1)
					//continue in next file from offset 0
					ContinueInNextRecord(dir, data_file, (dir==0)?files_from:files_to);
					ret_val = 1; 
				}

				
				if(data_to[data_to_size] == 0x01){
					data_to[data_to_size] = 0;
					data_to_size++;					//now it is length, not index
					break;
				}
			
				data_to_size++;
			}
			
//TEST:
//			s=new String(data_from);
//			s2=new String(data_to);
//mDavar.about.append(s2 + '\n');
			
			
		
		
		return ret_val;		//OK
	}

    
//-------------------------------------------------------------------------    

	//function close actual data record and open next one, set data_offset to 0 and data_file to next #
	//IN: 	direction 0=FROM->TO, 1=TO->FROM
	//		file: ONEBASED # of file which will be closed
	//		file_max: number of all data files
	//OUT:	0=OK, 1=problem

	public int	ContinueInNextRecord(int dir, int file, int file_max)throws IOException{

		String 			s = "";
		int				f;	

	
	
		try{        					//we must close old
			if(input != null){
				input.close();
			}
		} catch (IOException e) {}
	    
   		//create new string with name of file
   		f = file+1;
   		if(f>file_max){
   			return 1;
   		}
   		
		s = String.valueOf(f);
		
   		if(dir == 0){
   			s = "0000" + s;					//he->cz file
   			s = s.substring(s.length()-4, s.length());
   		}
   		else{								//cz->he file
   			s = "0000" + s + "i";			//i means "inversed"
   			s = s.substring(s.length()-5, s.length());	   			
   		}
		
	   		
   		//now open requested file
		input = new DataInputStream(getClass().getResourceAsStream(s));
		data_offset = 0;
		data_file = f;
		
			
		return 0;
	}

//-------------------------------------------------------------------------
    
    //find next sync mark 0x01 and set offset to next byte AFTER
	//used before  FIRST reading of record 
    //IN: 	direction requested: 0=FROM, 1=TO
    //		file: onebased # of file
    //		offset: zerobased offset in file
    
    //OUT:	0=OK, 1=error


	public int	FindNextSync(int dir, int file, int offset)throws IOException{

		String 			s = "";
		
				
		//WE ALWAYS REOPEN FILE! 

		try{        					//we must reopen file
			if(input != null){
				input.close();
			}
		} catch (IOException e) {}
	    
   		//create new string with name of file
   		s = String.valueOf(file);
	   		
   		if(dir == 0){
   			s = "0000" + s;					//he->cz file
   			s = s.substring(s.length()-4, s.length());
   		}
   		else{								//cz->he file
   			s = "0000" + s + "i";			//i means "inversed"
   			s = s.substring(s.length()-5, s.length());	   			
   		}
	   		
	   		
   		//now open requested file
		input = new DataInputStream(getClass().getResourceAsStream(s));
		data_offset = 0;
			
		//now skip bytes to requested offset
		while(data_offset < offset && data_offset < DATA_FILE_LEN){
			input.readByte();
			data_offset++;
		}

		
		//now we can read until get 01 as start of key FROM
		while(input.readByte()!= 0x01){
			data_offset++;
			if(data_offset >= (DATA_FILE_LEN-1) ){
				//error
				return 1;
			}
		}
		data_offset++;	//we are AFTER 0x01, was missing!	
		
		return 0;
	}

	// ------------------------------------------------------------------------------------
	
    //find next record will search forward 
    //IN: 	direction requested: 0=FROM, 1=TO
    //		file: onebased # of file
    //		offset: zerobased offset in file
    
    //OUT:	0=OK, 1=error


	public int	FindNextRecord(int dir, int file, int offset)throws IOException{

		String 			s = "";
		
		
		
		//first check if we have opened file in good direction and actual offset <= requested offset 
		if(	(dir != direction) ||
			(file != data_file) ||
			(offset < data_offset) ||
			(input == null))			{

			
			try{        					//we must reopen file
				if(input != null){
					input.close();
				}
			} catch (IOException e) {}
	    
	   		//create new string with name of file
	   		s = String.valueOf(file);

	   		if(dir == 0){
	   			s = "0000" + s;					//he->cz file
	   			s = s.substring(s.length()-4, s.length());
	   		}
	   		else{								//cz->he file
	   			s = "0000" + s + "i";			//i means "inversed"
	   			s = s.substring(s.length()-5, s.length());	   			
	   		}
	   		
	   		//now open requested file
			input = new DataInputStream(getClass().getResourceAsStream(s));
			data_offset = 0;
			data_file = file;	//!!!
			
			//now skip bytes to requested offset
			while(data_offset < offset && data_offset < DATA_FILE_LEN){
				input.readByte();
				data_offset++;
			}
		}
		
		//now we can read until get 01 as start of key FROM
		while(input.readByte()!= 0x01){
			data_offset++;
			if(data_offset >= (DATA_FILE_LEN) ){	//BUG: was (DATA_FILE_LEN-1)
				//continue in next file from offset 0
				ContinueInNextRecord(dir, data_file, files_from);
			}
		}
				
		data_offset++;	//we are AFTER 0x01, was missing!				

		if(data_offset >= (DATA_FILE_LEN) ){
			//continue in next file from offset 0
			ContinueInNextRecord(dir, data_file, files_from);
		}

		
		
		return 0;
	}
	

	// ------------------------------------------------------------------------------------
	
    //find previous record will search backward 
    //IN: 	direction requested: 0=FROM, 1=TO
    //		file: onebased # of file - ACTUAL RECORD ON THE TOP OF THE SCREEN
    //		offset: zerobased offset in file - ACTUAL RECORD ON THE TOP OF THE SCREEN
    
    //OUT:	0=OK, 1=error


	public int	FindPreviousRecord(int dir, int file, int offset)throws IOException{

		int				off_temp, file_temp;
//		String 			s = "";
		int				f=0;
		int				g=0;
		
		//if we have offset 0, then correct file&offset
		if(file <= 1 && offset <= 1){
				return 1;						//cannot move 
		}

		if(offset == 0){
			off_temp = DATA_FILE_LEN-1;
			file_temp = file--;								//end of previous file
		}
		else{
			off_temp = offset;
			file_temp = file;								//end of previous file
		}

		//now reopen file and read ALL content to buffer 
		try{
			f = ReadAllFile(dir, file_temp);
			f--;		//now we have OFFSET of last byte in array!
			g=f;								//remember offset of last item in file!
		} catch (IOException e) {}	
		
		f=off_temp;
		//now we can search backward for marks: 01, 02 and 01, use +1 position as previous record offset
		while(buf_record[f] != 0x01){
			f--;
			if(f<0){		//need read another file to buf_record[]
				file_temp--;
				if(file_temp <=0 ){
					return 1;				//error
				}
				
				try{
					f = ReadAllFile(dir, file_temp);	//open+read
					f--; 						//now we have OFFSET of last byte in array!
					g=f;								//remember offset of last item in file!
				} catch (IOException e) {}	
			}
		}

		//OK, we found first 0x01, now seeks for 0x02
		while(buf_record[f] != 0x02){
			f--;
			if(f<0){		//need read another file to buf_record[]
				file_temp--;
				if(file_temp <=0 ){
					return 1;				//error
				}
				
				try{
					f = ReadAllFile(dir, file_temp);	//open+read
					f--;		//now we have OFFSET of last byte in array!
					g=f;								//remember offset of last item in file!
				} catch (IOException e) {}	
			}
		}

		//now seek for 0x01
		while(buf_record[f] != 0x01){
			f--;
			if(f<0){		//need read another file to buf_record[]
				file_temp--;
				if(file_temp <=0 ){
					return 1;				//error
				}
				
				try{
					f = ReadAllFile(dir, file_temp);	//open+read
					f--;		//now we have OFFSET of last byte in array!
					g=f;								//remember offset of last item in file!
				} catch (IOException e) {}	
			}
		}
		
		//f is offset in file_temp, return +1 position: first character of HE string
		if(f == g){		//rare case-LAST byte in file was 0x01 => first byte of HE string is offset 0 in NEXT file!
			data_offset = 0;
			data_file = file_temp + 1;
		}
		else{
			data_offset = f+1;
			data_file = file_temp;
		}

		//unfortunatelly, we must AGAIN open file and seek to position because actual position is lost
		SeekToOffset(dir, data_file, data_offset);
		
		return 0;
	}
	
	// ------------------------------------------------------------------------------------

    //find previous record which will fit to page 
    //IN: 	direction requested: 0=FROM, 1=TO
    //		file: onebased # of file - ACTUAL RECORD ON THE TOP OF THE SCREEN
    //		offset: zerobased offset in file - ACTUAL RECORD ON THE TOP OF THE SCREEN
    
    //OUT:	0=OK, 1=error


	public int	FindPreviousPageRecord(int dir, int file, int offset)throws IOException{


		
		int		from, to;					//width of FROM / TO string in buffer
		byte	buf_from[] = new byte [128];	//temp buffer for FROM string
		byte	buf_to[] = new byte [128];		//temp buffer for TO string

		int		he, cz;						//width of HE and TRANSLATION text, in pixels
		
		int		c;						
	
		int		y;						//text height
		String	s;
		int		off_temp, file_temp;
		int		f=0;
		int		g=0;
		int		l, r;					//left, right border
		

		y=0;							//height of text
		
		//if we have offset 0, then correct file&offset
		if(file <= 1 && offset <= 1){			//cannot move
			data_offset = 1;		//0ffset 0 is 01 in first file!
			data_file = 1;
			SeekToOffset(dir, data_file, data_offset);	  
		}

		if(offset == 0){
			off_temp = DATA_FILE_LEN-1;
			file_temp = file--;								//end of previous file
		}
		else{
			off_temp = offset;
			file_temp = file;								//end of previous file
		}

		//now reopen file and read ALL content to buffer 
		try{
			f = ReadAllFile(dir, file_temp);
			f--;		//now we have OFFSET of last byte in array!
		} catch (IOException e) {}	

		
		f=off_temp;

		//now we can search backward for marks: 01(begin of actual record), 02 and 01
		//he/cz text is inserted to buffer (reversed). we care about buffering of files
		//first search for sync
		while(buf_record[f] != 0x01){
 			f--;

 			//--- we need to read another file ---
 			if(f<0){		//need read another file to buf_record[]
				file_temp--;
				if(file_temp <=0 ){
					data_offset = 1;		//0ffset 0 is 01 in first file!
					data_file = 1;
					SeekToOffset(dir, data_file, data_offset);	  
					return 0;				
				}
				try{
					f = ReadAllFile(dir, file_temp);	//open+read
					f--; 						//now we have OFFSET of last byte in array!
				} catch (IOException e) {}	
			}
		}
		f--;

		//--- we need to read another file ---
		if(f<0){		//need read another file to buf_record[]
			file_temp--;
			if(file_temp <=0 ){
				data_offset = 1;		//0ffset 0 is 01 in first file!
				data_file = 1;
				SeekToOffset(dir, data_file, data_offset);	  
				return 0;				
			}
			
			try{
				f = ReadAllFile(dir, file_temp);	//open+read
				f--;		//now we have OFFSET of last byte in array!
			} catch (IOException e) {}	
		}
		
		
	do{
		//OK, we found first 0x01, now seeks for 0x02
		to = 0;
		while(buf_record[f] != 0x02){
			buf_to[to++] = buf_record[f];	//copy to, reversed
			f--;

			//--- we need to read another file ---
			if(f<0){		//need read another file to buf_record[]
				file_temp--;
				if(file_temp <=0 ){
					data_offset = 1;		//0ffset 0 is 01 in first file!
					data_file = 1;
					SeekToOffset(dir, data_file, data_offset);	  
					return 0;				
				}
				
				try{
					f = ReadAllFile(dir, file_temp);	//open+read
					f--;		//now we have OFFSET of last byte in array!
				} catch (IOException e) {}	
			}
		}
		buf_to[to++] = 0;		//final \0
		f--;

		//--- we need to read another file ---
		if(f<0){		//need read another file to buf_record[]
			file_temp--;
			if(file_temp <=0 ){
				data_offset = 1;		//0ffset 0 is 01 in first file!
				data_file = 1;
				SeekToOffset(dir, data_file, data_offset);	  
				return 0;				
			}
			try{
				f = ReadAllFile(dir, file_temp);	//open+read
				f--;		//now we have OFFSET of last byte in array!
			} catch (IOException e) {}	
		}
		
		
		//now seek for 0x01
		from = 0;
		while(buf_record[f] != 0x01){
			buf_from[from++] = buf_record[f];	//copy from, reversed
			f--;
		
			//--- we need to read another file ---
			if(f<0){		//need read another file to buf_record[]
				file_temp--;
				if(file_temp <=0 ){
					data_offset = 1;		//0ffset 0 is 01 in first file!
					data_file = 1;
					SeekToOffset(dir, data_file, data_offset);	  
					return 0;				
				}
				
				try{
					f = ReadAllFile(dir, file_temp);	//open+read
					f--;		//now we have OFFSET of last byte in array!
				} catch (IOException e) {}	
			}
		}
		buf_from[from++] = 0; //final \0
		//we are now at 0x01, want offset of first FROM character:
//PROBLEM: if we are on LAST char of buffer, increase f will point to [DATA_FILE_LEN],
//that is the reason why we have DATA_FILE_LEN+1 allocated!
		f++;

		

		//get HE string width. 

		he=0;							//HE width
		for(g=0; g < from; g++){
			c=buf_from[g]-32;			//index obrazku, pozor, je tam offset 32 ([0] je space!)
			//POZOR: pokud je c<0, jde o VOKAL! Preskocime jej (jinak vyjimka indexu!)
			if(c<0){
				continue;
			}

			he+=TextGraphics.HEBREW_W[mDavar.big_he][c];
		}

		//Get TRANSLATION string width, convert it to unicode
		cz=0;
		s=new String (buf_to);


		s=Convert2Unicode(s, to); //prekodujeme

		try{cz = mDavar.g_font.stringWidth(s.substring(0, to - 1));} 
		catch(Exception e) {}

		
		//TED ZJISTIME, NA KOLIK RADKU TO VYJDE A INCR. Y. 
		if((he + cz + TextGraphics.AVERAGE_CHAR_WIDTH) < mDavar.DISPLAY_SIZE_X){	//ok, vlezeme se
			y += (mDavar.g_font.getHeight() > TextGraphics.HE_CHARS_HEIGHT) ? mDavar.g_font.getHeight() : TextGraphics.HE_CHARS_HEIGHT;
		}
		else{	//nevlezeme: odecteme od velikosti displeje
			g = he+cz;		//celkova sirka
			while(g>0){
				g -= (mDavar.DISPLAY_SIZE_X - TextGraphics.AVERAGE_CHAR_WIDTH);	//
				y+=(mDavar.g_font.getHeight() > TextGraphics.HE_CHARS_HEIGHT) ? mDavar.g_font.getHeight() : TextGraphics.HE_CHARS_HEIGHT;
			}
		}

		
		
	}while(y < (mDavar.DISPLAY_SIZE_Y  - TextGraphics.HE_CHARS_HEIGHT)); //konec hlavniho do	

  		
		data_offset = f;
		data_file = file_temp;
  		

		//unfortunatelly, we must AGAIN open file and seek to position because actual position is lost
		SeekToOffset(dir, data_file, data_offset);
	
	
		return 0;
		
	} 

//----------------------------------------------------------------//
	
	
	
    //Read all file to buf_record[] 
    //IN: 	direction requested: 0=FROM, 1=TO
    //		file: onebased # of file
    
    //OUT:	Number of bytes which were red to buf_record[]
	
	//WARNING: POSITION IN ACTUAL input stream is LOST!!!
	//ALSO, data_file and data_offset are INVALID (due to lost of position in stream)


	public int	ReadAllFile(int dir, int file)throws IOException{

		String 			s = "";
		int				f;
		
		
		//now reopen file and read ALL content to buffer 
		try{        					//we must reopen file
			if(input != null){
				input.close();
			}
		} catch (IOException e) {}
	    
   		//create new string with name of file
   		s = String.valueOf(file);

   		if(dir == 0){
   			s = "0000" + s;					//he->cz file
   			s = s.substring(s.length()-4, s.length());
   		}
   		else{								//cz->he file
   			s = "0000" + s + "i";			//i means "inversed"
   			s = s.substring(s.length()-5, s.length());	   			
   		}
   		
   		
   		//now open requested file
		input = new DataInputStream(getClass().getResourceAsStream(s));
			
		//read all file to buffer 
		f=0;
		while(f < DATA_FILE_LEN){
			try{
				buf_record[f] = input.readByte();
				f++;
				
			}catch (EOFException e) {
				break;
			}
		}
		
		return f;
	}
	

	// ------------------------------------------------------------------------------------

    //Seek in file to position offset 
    //IN: 	direction requested: 0=FROM, 1=TO
    //		file: onebased # of file
    //		offset: zerobased offset in file.
    
    //OUT:	0=OK, 1=error


	public int	SeekToOffset(int dir, int file, int offset)throws IOException{

		int				off_temp, file_temp;
		String 			s = "";
		int				f;
	
		
		try{        					//we must reopen file
			if(input != null){
				input.close();
			}
		} catch (IOException e) {}
    
   		//create new string with name of file
   		s = String.valueOf(file);

   		if(dir == 0){
   			s = "0000" + s;					//he->cz file
   			s = s.substring(s.length()-4, s.length());
   		}
   		else{								//cz->he file
   			s = "0000" + s + "i";			//i means "inversed"
   			s = s.substring(s.length()-5, s.length());	   			
   		}
   		
   		//now open requested file
		input = new DataInputStream(getClass().getResourceAsStream(s));
		data_offset = 0;
		data_file = file;
		
		//now skip bytes to requested offset
		while(data_offset < offset && data_offset < DATA_FILE_LEN){
			input.readByte();
			data_offset++;
		}

		return 0;
	}		

	
	// ------------------------------------------------------------------------------------
    // int type reverse presentation
    private static int reverseBytes(int number) {
        return ((number & 0xFF000000) >>> 24) | ((number & 0x00FF0000) >>> 8) | ((number & 0x0000FF00) << 8) | ((number & 0x000000FF) << 24);
    }
    
    // ------------------------------------------------------------------------------------


    //prevede 1 byte kodovani CZ (Windows) na 2 byte (Unicode)
    //Nova verze-pouziva tabulku kodovani z MDD. Melo by tedy byt univerzalni, ne jen CZ
    //IN: s-string, len - pocet znaku, ktere prekodujeme (s muze byt delsi)
    //OUT: prekodovany string

    //POZOR: bylo DOST pomale - string ma velikost 256 bytes, takze zaveden parametr,
    //do switch jdou jen znaky >=128
    //Win kodovani je v razeni[0][256] - 1. byte
    //Unicode kodovani je v razeni[2][256] - 2.byte

    static public String Convert2Unicode(String s, int len){

    	String	out = new String();
    	int		f, g;
    	char	c;
    	
    	for(f=0; f < len; f++){		
    		c=s.charAt(f);

    		if(c>=128){               //prekodovavame jen narodni znaky
                //bohuzel, ted to musime projet vse. Resenim jak to zrychlit by 
                //bylo mit dve int pole[128] ktera by mapovala znaky nad 128.
                //zatim zkusime takhle pomalu
                for(g=0; g<256; g+=2){  //netreba testovat na 0 0 (vzdy se neco prekoduje!)
                    if(sorting[0][g] == c){
                        c=(char)sorting[2][g+1];
                        break;
                    }
                }
    		}

    		out=out+c;
    	}
    	return out;	
    }

    //--------------------------------------------------------------------------------    

    // ------------------------------------------------------------------------------------


    //prevede 2 byte kodovani UNICODE na 1 byte CZ (Windows)
    //Nova verze-pouziva tabulku kodovani z MDD. Melo by tedy byt univerzalni, ne jen CZ
    //IN: s-string, len - pocet znaku, ktere prekodujeme (s muze byt delsi)
    //OUT: prekodovany string

    //POZOR: bylo DOST pomale - string ma velikost 256 bytes, takze zaveden parametr,
    //do switch jdou jen znaky >=128
    //Win kodovani je v razeni[0][256] - 1. byte
    //Unicode kodovani je v razeni[2][256] - 2.byte

    static public String ConvertFromUnicode(String s, int len){

    	String	out = new String();
    	int		f, g;
    	char	c;
    	
    	for(f=0; f < len; f++){		
    		c=s.charAt(f);

    		if(c>=128){               //prekodovavame jen narodni znaky
                //bohuzel, ted to musime projet vse. Resenim jak to zrychlit by 
                //bylo mit dve int pole[128] ktera by mapovala znaky nad 128.
                //zatim zkusime takhle pomalu
                for(g=0; g<256; g+=2){  //netreba testovat na 0 0 (vzdy se neco prekoduje!)
                    if(sorting[2][g+1] == c){
                        c=(char)sorting[0][g];
                        break;
                    }
                }
    		}

    		out=out+c;
    	}
    	return out;	
    }
    
    
}
    
    
