/*
 
mDavar 2.0 - Simple Hebrew dictionary for J2ME
Copyright (C) 2007 Josef Planeta <freedavar@centrum.cz>
Copyright (C) 2007 Vladimir Marcenko <vladimir-2@rambler.ru>

 
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 
*/

import java.io.IOException;

import javax.microedition.lcdui.*; 
import javax.microedition.midlet.MIDletStateChangeException;

// definice nov tdy, potomka tdy Canvas 
public class Search extends Canvas implements CommandListener{ 


	public		static 		Image 		iTable; 
	public		final int 	TABLE_WIDTH[] 			= {72, 120, 144};		//table width for small/big hebrew
	public		final int 	TABLE_HEIGHT[]  		= {42, 57, 78};			//vyska tabulky
	public		final int 	TABLE_CHAR_WIDTH[] 		= {9, 15, 18};			//sirka znaku
	public		final int 	TABLE_CHAR_HEIGHT[]  	= {13,19, 26};			//vyska znaku


	//pole ktere mapuje tabulku HE znaku
	public 		final int	TABLE_CHAR[][]= {	{ 71,  70,  69,  68,  67,  66,  65,  64},
												{ 82,  81,  80,  78,  76,  75,  73,  72},
												{  0,   0,  90,  89,  88,  87,  86,  84} };	


	public static int		f;
	public static int		CUR_X = 3;		//KURZOR SLOUPEC, ZEROBASED
	public static int		CUR_Y = 0;		//KURZOR RADEK, ZEROBASED
	

	
	Command deleteCommand = new Command("Delete", Command.BACK, 1);    
	Command searchCommand = new Command("Search", Command.SCREEN, 1);
		
		
	    //constructor - add commands
	    public Search(){
	    	
	    	addCommand(deleteCommand);
	    	addCommand(searchCommand);
	        
	        
	        setCommandListener(this);
	    }
	

	
//-----------------------------------------------------------------------------------	

	public void paint(Graphics g) { 

		int		f;				//pomocna
		int		w;				//soucet sirek znaku he stringu
					
		// nejprve nastavme barvu podkladu a vyplnme display obdlnkem o maximln ce a vce 
		g.setColor(Options.options[8]);	//0, 255, 0); 
		g.fillRect(0, 0, mDavar.DISPLAY_SIZE_X, mDavar.DISPLAY_SIZE_Y); 

		// vykreslme obrzek tabulky znaku umstn uprostred displeje a hozeny dolu
		g.drawImage(iTable, (mDavar.DISPLAY_SIZE_X-TABLE_WIDTH[mDavar.big_he])/2, (mDavar.DISPLAY_SIZE_Y-TABLE_HEIGHT[mDavar.big_he]), Graphics.TOP | Graphics.LEFT); 

		//vykreslime kurzor (ohraniceni HE znaku)
		g.setColor(255, 0, 0); 	//RED
		g.setStrokeStyle(0);	//SOLID	//pro jistotu
		g.drawRect((mDavar.DISPLAY_SIZE_X-TABLE_WIDTH[mDavar.big_he])/2 + CUR_X*TABLE_CHAR_WIDTH[mDavar.big_he], 
				mDavar.DISPLAY_SIZE_Y-TABLE_HEIGHT[mDavar.big_he] + CUR_Y*TABLE_CHAR_HEIGHT[mDavar.big_he], 
					TABLE_CHAR_WIDTH[mDavar.big_he]-1, 
					TABLE_CHAR_HEIGHT[mDavar.big_he]-1); 	

		//vykreslime zadany HE string. 
		w=0;
		for(f=0; f< mDavar.key_size_HE; f++){
			g.drawImage(TextGraphics.heImg[(mDavar.key_HE[f]-32)], 
						mDavar.DISPLAY_SIZE_X-w, 
						10, 
						Graphics.TOP | Graphics.RIGHT); 
			w+=TextGraphics.HEBREW_W[mDavar.big_he][(mDavar.key_HE[f]-32)];
		}

//TEST		
//g.setColor(0, 0, 0); 
//g.drawString("Debug1= " + MainClass.DEBUG1, 0, 0, g.TOP | g.LEFT);
//g.drawString("" + MainClass.razeni[2][16] + " " + MainClass.razeni[3][16], 0, 0, g.TOP | g.LEFT);
		
	} //paint()

	
    
    //user drzi klavesu
    protected void keyRepeated(int key){
        keyPressed(key);
    }




	
	//user stiskl klavesu
	protected void keyPressed(int key){
		


			//1=DELETE
			if(	key == Canvas.KEY_NUM1){ 			
				//delete znaku
				mDavar.key_size_HE=(mDavar.key_size_HE > 0) ? mDavar.key_size_HE-=1 : 0;					
			}

			//3=OK
			if(	key == Canvas.KEY_NUM3){ 			

                //Pozor-data jsou v bufferu vporadi: alef, bet, gimmel
                //proto pri hledani uz jen staci otacet HE recordy
                //MainClass.OtocHEkey();

				SearchHebrew();			//will call search for entered HE string
				mDavar.ShowHebrewDictCanvas();	//then return to HE list of words

			}
		
		
			if(	key == Canvas.KEY_NUM6 ||
				getGameAction(key) == Canvas.RIGHT){ //Right
				CUR_X=(CUR_X < 7)? CUR_X+1 : 0;
			}

			if(	key == Canvas.KEY_NUM4 ||
				getGameAction(key) == Canvas.LEFT){ //Left
				CUR_X=(CUR_X > 0)? CUR_X-1 : 7;
			}

			if( key == Canvas.KEY_NUM2 ||
				getGameAction(key) == Canvas.UP){ //Up
				CUR_Y=(CUR_Y > 0)? CUR_Y-1 : 2;				
			}

			if(	key == Canvas.KEY_NUM8 ||
				getGameAction(key) == Canvas.DOWN){ //Down
				CUR_Y=(CUR_Y <= 1)? CUR_Y+1 : 0;				
			}
	
			if(	key == Canvas.KEY_NUM5 ||
				getGameAction(key) == Canvas.FIRE){ //Potvrzeni HE znaku

				//Pokud je policko DEL:
				if(CUR_Y == 2 && CUR_X == 0){
					mDavar.key_size_HE=(mDavar.key_size_HE > 0) ? mDavar.key_size_HE-=1 : 0;
				}
				else{	//OK
					if(CUR_Y == 2 && CUR_X == 1){
                        //Pozor-data jsou v bufferu vporadi: alef, bet, gimmel
                        //proto pri hledani uz jen staci otacet HE recordy
                        //MainClass.OtocHEkey();

						SearchHebrew();			//will set data_file and data_offset
						mDavar.ShowHebrewDictCanvas();
                    
                    }
					else{	//HE znak
						//aktualizujeme key, pokud jeste neni max dlouhy
						if(mDavar.key_size_HE < mDavar.KEY_SIZE_MAX){
							mDavar.key_HE[mDavar.key_size_HE]=TABLE_CHAR[CUR_Y][CUR_X];
							mDavar.key_size_HE++;
						}

					}
				}
				

			} //konec key5

			repaint();
	
		}
	//------------------------------------------------------------------------------------
	 
	public void commandAction(Command c, Displayable d) {
	        if(c == searchCommand){
	            keyPressed(Canvas.KEY_NUM3);
	        }
	        
	        else if(c == deleteCommand){
	        	keyPressed(Canvas.KEY_NUM1);
	        }
	        	
	    }    
	  	

	//-----------------------------------------------------------------------------------
	
	public static int loadHebrewTable(){
	
		try { 
			
			iTable = null;
			
			// pouijeme metodu createImage tdy Image 
			if(mDavar.big_he == 0)
				iTable = Image.createImage("/table.png");
			if(mDavar.big_he == 1)
				iTable = Image.createImage("/table2.png");
			if(mDavar.big_he == 2)
				iTable = Image.createImage("/table3.png");

			
			// odchycen mon vjimky 
		} 
		catch(Exception e) { }
		
		return 0;
	}
	
	
	//--------------------------------------------------------------

	//Search for HE string
	//IN: mDavar: key_HE[]
	//OUT: mDavar: data_offset and data_file which fits to found he word

	public static int SearchHebrew()
	{
	int		f, g, h;
	String	s = "";					//string from index
	String	key=new String();		//user's HE key
	int		sl;						//string length
	int		kl;						//key length
	int		bytes_in_buf;
	int		res;
	
	
	
	for(f=0; f< mDavar.key_size_HE; f++){
		key=key+(char)mDavar.key_HE[f];
	}


	try{
		
	
		//now we will search for HE keyword in index, which is >= then inserted key
		//Will use linear search, we have typically up to ~ 100 files
		for(f=0; f< MDD.files_from; f++){
			s = "";

			//create string in opposite order - for compare!
			for(g = MDD.key_length-1; g>=0; g--){
				if(MDD.key_from[f][g] == 0){	
					continue;
				}
				s=s+(char)MDD.key_from[f][g];
			}
			
		
			//we have now HE string from index, compare
			sl = s.length();
			kl = key.length();

//DEBUG:
//System.out.println(f + ". key= " + key + " index= " + s + "flag = "+mDavar.mdd.flag_from[f]+'\n');
			
			res = CompareStrings(s, key, sl, kl, 1);
		
			if(	res == 1 ||										//index word >= key 
				(f == (MDD.files_from-1) && res != 1)	){		//or we got last file

				//so, f+1 is number of file, but f-1 is PREVIOUS file which we need
				mDavar.mdd.data_file = f;				//f+1-1 is # of file
				
				if(mDavar.mdd.data_file <= 0)			//fixed: if result of compare points to PREVIOUS
					mDavar.mdd.data_file=1;				//file, we can have forst file ==1, not 0!

				//if flag "same from word in previous file" was set, will read previous file
//				if(mDavar.mdd.flag_from[f] == 1){
//					mDavar.mdd.data_file--;
//				}

				
				//will read all record to buffer
				bytes_in_buf = mDavar.mdd.ReadAllFile(0, mDavar.mdd.data_file);

				mDavar.mdd.data_offset = SearchInDataBuffer(key, bytes_in_buf, 1);				

				if(mDavar.mdd.data_offset == -1){		//will try next file
					
					mDavar.mdd.data_file++;
					
					//will read all record to buffer
					bytes_in_buf = mDavar.mdd.ReadAllFile(0, mDavar.mdd.data_file);
					mDavar.mdd.data_offset = SearchInDataBuffer(key, bytes_in_buf, 1);

					//if we NOW get returned  mDavar.mdd.data_offset = -1, then user probably
					//entered too HIGH key. We will find LAST record offset in already filled buf_record[]
					if(mDavar.mdd.data_offset == -1){
						for(h=bytes_in_buf-1; h>=0; h--){
							//just sek backwards for first 0x01 marker
							if(mDavar.mdd.buf_record[h] == 0x01){
								mDavar.mdd.data_offset = h+1;
								break;
							}
						}
					}
					
				}
				
				
				mDavar.mdd.SeekToOffset(0, mDavar.mdd.data_file, mDavar.mdd.data_offset);
			
				return 0;
			
			}
		
		}
	} catch (IOException e) {}

	
	
	
	
	return 0;
	}

	//--------------------------------------------------------------

	//Search for string in buffer
	//IN: key to search for. For HE is already opposite, 
	//buf length, type: 1=HE, 0=latin based(translation)
	//OUT: offset of FROM string in data >= then key. -1 = NOT FOUND or INCLOMPLETE FROM STRING 

	public static int SearchInDataBuffer(String key, int buf_len, int type){
		

		int		f, g, h, i;
		int		flag;
		int		l=0;					//left, right offsets of FROM word
		int		r=0;
		String	s = "";
		int		sl;						//string length
		int		kl;						//key length

		
		h=0;
		flag = 0;		//0=no 01 was found yet, 1=01 was found, 02 was found
		do{
			if(mDavar.mdd.buf_record[h] == 0x01){	//start of word
				flag = 1;
				h++;			//from, first char
				l = h;			//START OF WORD
				continue;
			}
			
			if(mDavar.mdd.buf_record[h] == 0x02 && flag == 1){
				flag = 2;
				r = h - 1;				//END of word
				h++;			//start of translation

				//now prepare word FROM, for HE in opposite order
				s="";
				if(type == 1){								//HEBREW
					for(g = r; g>=l; g--){
						if(mDavar.mdd.buf_record[g] == 0){	
							continue;
						}
						s=s+(char)mDavar.mdd.buf_record[g];
					}
				}
				else{										//LATIN BASED
					for(g = l; g<=r; g++){
						//FIXED: correction to chars >256!
						i = (mDavar.mdd.buf_record[g]<0) ? 256+mDavar.mdd.buf_record[g] : mDavar.mdd.buf_record[g];
						if(i == 0){	
							continue;
						}
						s=s+(char)i;
					}
				}

				sl = s.length();
				kl = key.length();

				
				if(CompareStrings(s, key, sl, kl, type) >= 0){		//index word >= key
					return l;
				}
			}
			
			h++;
			
				
			
		}while(h<buf_len);
		
		
		
		return -1;
	}
	

	//-------------------------------------------------------------------

	//Search for CZ(translation) string
	//IN: mDavar: key_CZ[]
	//OUT: mDavar: data_offset and data_file which fits to found he word

	static public int SearchCZ()
	{
	int		f, g, h, i;
	String	s = "";					//string from index
	String	key=new String();		//user's CZ key
	int		sl;						//string length
	int		kl;						//key length
	int		bytes_in_buf;
	int		res;
	
	
	
	for(f=0; f< mDavar.key_size_CZ; f++){
		key=key+(char)mDavar.key_CZ[f];
	}
	
	key = MDD.ConvertFromUnicode(key, key.length()); //prekodujeme Z UNICODE

	try{
		
	
		//now we will search for CZ keyword in index, which is >= then inserted key
		//Will use linear search, we have typically up to ~ 100 files
		for(f=0; f< MDD.files_to; f++){
			s = "";

			//create string from index - for compare!
			for(g = 0; g<MDD.key_length; g++){

				i = (MDD.key_to[f][g] < 0) ? 256+MDD.key_to[f][g] : MDD.key_to[f][g];    //korekce na signed byte
				if(i == 0){	
					continue;
				}
				
				s=s+(char)i;  

			}
			
			//we have now CZ string from index, compare
			sl = s.length();
			kl = key.length();

//DEBUG:
//System.out.println(f + ". key= " + key + " index= " + s + " ,flag = "+mDavar.mdd.flag_from[f]+'\n');
			
			res = CompareStrings(s, key, sl, kl, 0);
		
			if(	res == 1 ||										//index word >= key 
				(f == (MDD.files_to-1) && res != 1)	){		//or we got last file

				//so, f+1 is number of file, but f-1 is PREVIOUS file which we need
				mDavar.mdd.data_file = f;				//f+1-1 is # of file
				
				if(mDavar.mdd.data_file <= 0)			//fixed: if result of compare points to PREVIOUS
					mDavar.mdd.data_file=1;				//file, we can have forst file ==1, not 0!


				//if flag "same from word in previous file" was set, will read previous file
//				if(mDavar.mdd.flag_from[f] == 1){
//					mDavar.mdd.data_file--;
//				}

				
				//will read all record to buffer
				bytes_in_buf = mDavar.mdd.ReadAllFile(1, mDavar.mdd.data_file);

				mDavar.mdd.data_offset = SearchInDataBuffer(key, bytes_in_buf, 0);				

				if(mDavar.mdd.data_offset == -1){		//will try next file
					
					mDavar.mdd.data_file++;
					
					//will read all record to buffer
					bytes_in_buf = mDavar.mdd.ReadAllFile(1, mDavar.mdd.data_file);
					mDavar.mdd.data_offset = SearchInDataBuffer(key, bytes_in_buf, 0);

					//if we NOW get returned  mDavar.mdd.data_offset = -1, then user probably
					//entered too HIGH key. We will find LAST record offset in already filled buf_record[]
					if(mDavar.mdd.data_offset == -1){
						for(h=bytes_in_buf-1; h>=0; h--){
							//just sek backwards for first 0x01 marker
							if(mDavar.mdd.buf_record[h] == 0x01){
								mDavar.mdd.data_offset = h+1;
								break;
							}
						}
					}
					
				}
				
				
				mDavar.mdd.SeekToOffset(1, mDavar.mdd.data_file, mDavar.mdd.data_offset);
			
				return 0;
			
			}
		
		}
	} catch (IOException e) {}

	
	
	
	
	return 0;
	}

	//--------------------------------------------------------------



	
	
	//will reverse buffer
	static public void ReverseBuf(byte[] buf, int size)
	{
	int 	f;
	byte	g;

	for(f=0; f<(size/2); f++){
	    g=buf[f];
	    buf[f] = buf[(size-1) - f];
	    buf[(size-1) - f] = g;
	}

	return;
	}

	//-------------------------------------------------------------------

	//Obecna porovnavaci funkce pro dva stringy.
	//IN: 	string a,
//			string b,
//	      delka a, b
//			typ stringu: 0=CZ, 1=HE
	//OUT:	(-1)	a<b
//		  	(0)		a=b
//			(+1)	a>b
	//POZOR: Sprezka NESMI mit druhy znak nulovy! Pak to NENI jako sprezka!

	//DODELANO: Pokud najdeme hit v zakladni radici tabulce, jdeme jeste do "mapy", ktera je dale. 
	//Pokud ma znak "bratricky", tak dojedeme az do posledniho.
	//POZOR: To cele pracuje na zaklade toho, ze mapa SDRUZUJE OBLASTI ZAKLADNI TABULKY, KTERE JSOU
	//VEDLE SEBE!! Jinak bychom nemohli porovnavat vysledne indexy z mapy!!!!!!!
	//POkud je v mape 1, pak nasledujici znak si je s danym roven. Pokud je 0, pak ukoncime hledani
	//stejnych znaku

	//DODELANO: Fixed pripad napr. bet s vokalem (neni v tabulce) a bet s alefem. Znak, ktery mel
	//hit je delsi, za bet s vokelam uz neni hit, je tudiz kratsi!


	static public int CompareStrings(String a, String b, int la, int lb, int typ)
	{

	int		fa, fb;			//flags, 1=nalezen hit v tabulce, 0=nenalezen
	int		ta, tb;			//ukazatele na pozici v tabulce (PRVNI ze dvou hodnot)
	int		pa, pb;			//ukazatele na pozice stringu.
	int     sa, sb;         //shoda prvniho znaku v tabulce. -1 je inic, pokud != -1 tak byla shoda
	int     chars_a, chars_b; //celkem NALEZENYCH znaku v tabulce


	pa=0;
	pb=0;
	ta=0;	//at J nerve
	tb=0;	//at J nerve
	chars_a=0;
	chars_b=0;

//DEBUG
//String s1=a+" Length a(rec)="+la+"  ";
//String s2=b+" Length b(key)="+lb+"  ";
//System.out.println(s1 +"  "+ s2+'\n');
//DEBUG



	do{					//do konce DELSIHO bufferu, ale jsou tam i break;

	    fa=0;
	    fb=0;
	    sa=-1;      //nebyla shoda prvniho znaku s tabulkou
	    sb=-1;      //nebyla shoda prvniho znaku s tabulkou

	    //najdeme prvni hit pro buffer a
		while((fa != 1) && (pa < la)){					//dokud neni hit nebo konec bufferu

	        //poznamename si prvni shodu znaku, pak hledame sprezky. 
	        ta=0;                     //pozice v tabulce
		    while(!(MDD.sorting[typ][ta] == 0 && MDD.sorting[typ][ta+1]==0)){			//az do konce VYUZITE tabulky
	            if( a.charAt(pa) == MDD.sorting[typ][ta] ){				//shoda 1. znaku


	                if (sa == -1){                      //pokud je shoda POPRVE, ulozime do sa
	                    sa=ta;      //uloz pozici shody. POZOR - fa nemenime, sa je jako flag (!= -1)
	       			
	                    //podivame, jestli nalezeny znak nema brachy v mape. Pokud ano, dojedeme az k poslednimu.
	        			while(MDD.sorting[typ+2][sa] != 0)
	    	       			sa+=2;

	                }
	                //shoda druheho znaku, udelame ZNOVU test na velikost pole (pa)
	                //shoda ve sprezce, SPREZKA ALE NEMA DRUHY ZNAK NULOVY! toto zde take testujeme!
	    		    if((pa+1) < la && (a.charAt(pa+1) == MDD.sorting[typ][ta+1]) && a.charAt(pa+1) != 0) {	
	                	pa++;					//posun ukazatel, byla sprezka
	    	       		fa=1;					//nahod flag
	    

	        			//DODELANO:ted se podivame, jestli nalezeny znak nema brachy v mape.
	    	       		//Pokud ano, dojedeme az k poslednimu.
	    		      	while(MDD.sorting[typ+2][ta] != 0)
	        				ta+=2;
	    
	    	       		break;					//ta/2 udava nalezenou pozici
	        		}
	    	   }
	    	   ta+=2;							//POZOR, posun na dalsi dvojici v tabulce
		   }
	       //dva zpusoby ukonceni: 1-projeta cela tabulka, 2-break
	       if(fa!=1 && sa!=-1){    //nebyla sprezka (fa se nastavi na 1 jen pro sprezku) ale
	            fa=1;               //byl hit znaku v tabulce. Takze nastavime ta a fa
	            ta=sa;

	        }  
	        
		    pa++;									//pa ukazuje na DALSI (testovanou) pozici
		}



	//najdeme prvni hit pro buffer b
		while((fb != 1) && (pb < lb)){					//dokud neni hit nebo konec bufferu

	        //poznamename si prvni shodu znaku, pak hledame sprezky. 
			tb=0;
			while(!(MDD.sorting[typ][tb] == 0 && MDD.sorting[typ][tb+1]==0)){			//az do konce VYUZITE tabulky
				if( b.charAt(pb) == MDD.sorting[typ][tb]){				//shoda 1. znaku

				     if (sb == -1){                      //pokud je shoda POPRVE, ulozime do sb
				     
	                    sb = tb;      //uloz pozici shody. POZOR - fb nemenime, sb je jako flag (!= -1)
	   					//podivame, jestli nalezeny znak nema brachy v mape. Pokud ano, dojedeme az k poslednimu.
						while( MDD.sorting[typ+2][sb] != 0)
							sb+=2;

	                 }

	                //shoda druheho znaku, udelame ZNOVU test na velikost pole (pb)
	                //shoda ve sprezce, SPREZKA ALE NEMA DRUHY ZNAK NULOVY! toto zde take testujeme!
					if((pb+1) < lb && (b.charAt(pb+1) == MDD.sorting[typ][tb+1]) && b.charAt(pb+1) != 0)   {	
						pb++;					//posun ukazatel, byla sprezka
						fb=1;					//nahod flag


						//DODELANO:ted se podivame, jestli nalezeny znak nema brachy v mape.
						//Pokud ano, dojedeme az k poslednimu.
						while(MDD.sorting[typ+2][tb] != 0)
							tb+=2;

						break;					//ta/2 udava nalezenou pozici
					}
				}
				tb+=2;							//POZOR, posun na dalsi dvojici v tabulce
			}

	        //dva zpusoby ukonceni: 1-projeta cela tabulka, 2-break
	        if(fb!=1 && sb!=-1){    //nebyla sprezka (fb se nastavi na 1 jen pro sprezku) ale
	            fb=1;               //byl hit znaku v tabulce. Takze nastavime tb a fb
	            tb=sb;
	        }  

	    	pb++;									//pa ukazuje na DALSI (testovanou) pozici
		}

	    
//DEBUG
//s1="ta(rec)="+ta+", VAL(ta)="+MDD.sorting[typ][ta]+"  ";
//s2="tb(key)="+tb+" VAL(tb)="+MDD.sorting[typ][tb]+"  ";
//System.out.println(s1 +"  "+ s2+'\n');
//DEBUG

	    //update poctu nalezenych znaku
		if(fa == 1)  chars_a++;
		if(fb == 1)  chars_b++;

		
	    //pokud je fa && fb 1, pak byly hity a je co porovnat
		if((fa == 1) && (fb == 1)){				//mame hity z obou bufferu, porovname
			//ta=ta/2;							//ted spocitame pozice, od 0
			//tb=tb/2;

			if(ta<tb)
				return -1;						//a<b
			if(ta>tb)
				return	1;						//a>b
		}
		//DODELANO: BUG: bez tohoto to spatne rozlisilo napr. bet s vokalem a bet s alefem!
		else{      //alespon jeden z bufferu nemel hit. Ten ktery mel hit je DELSI(=VETSI)!!
			if(fa == 1 && fb != 1){			//a melo hit, je delsi!
				return	1;						//a>b
			}
			if(fa != 1 && fb == 1){			//b melo hit, je delsi!
				return -1;						//a<b
			}
		}
		////////////



		//pokud se dostane sem, byly stringy stejne a udelame dalsi kolo
	}while(pa < la || pb < lb); //do konce delsiho




	//pokud je to tady, stringy jsou bud totozne(a stejne dlouhe) nebo je jeden
	//kratsi, ale spolecna delka byla stejna

	if(chars_a < chars_b)		//string b jeste neco obsahuje, je delsi!
		return	-1;

	if(chars_a > chars_b)		//string a jeste neco obsahuje, je delsi!
		return	1;

	//posledni moznost-stringy jsou stejne
	return 0;

	}
	//-------------------------------------------------------------------
	
	
	
}//class







 
