/*
 
mDavar 2.0 - Simple Hebrew dictionary for J2ME
Copyright (C) 2007 Josef Planeta <freedavar@centrum.cz>
Copyright (C) 2007 Vladimir Marcenko <vladimir-2@rambler.ru>

 
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 
*/


import javax.microedition.midlet.*;

import java.io.*;

import javax.microedition.lcdui.*;


public class mDavar extends MIDlet {
    
     public static		Splash			splash;
     public static		MDD 			mdd;
     public	 static		DictHE			dict_he;	//Hebrew->CZ translation
     public	 static		DictCZ			dict_cz;	//CZ->Hebrew translation
     public static		Form			about;	    //about form
     public static		Canvas			search;	    //search class: input HE key+search
     public static		Options			options;
     
     int				f;

     public static 	Font 			g_font;		//global font for text out. Will be used in other classes 
     public static 	int 			DISPLAY_SIZE_X;	//sirka displeje
     public static 	int 			DISPLAY_SIZE_Y;	//vyska displeje

     public static 	final int		KEY_SIZE_MAX  			= 20;	//max size of key     
     public static 	int 			key_HE []=new int [KEY_SIZE_MAX];		//he key for search
     public static 	int 			key_CZ []=new int [KEY_SIZE_MAX];		//translation key for search
     public static 	int 			key_size_HE;					//actual size of HE key
     public static 	int 			key_size_CZ;					//actual size of translation key

     
     public static		Display 		display;   

     public static 	mDavar			instance; 						//store instance of mDavar class
     
     public static    int				big_he=0;	//2=SUPER BIG, 1=big hebrew table and chars, 0=small. Is used as index to array! 

     // ---------------  Creates a new instance of mDavar - constructor -------------

    public mDavar() {       

    	instance = this;
    	
    	display = Display.getDisplay(this);

    	// vytvome novou instanci tdy Splash, kter je definovna v souboru Splash.java 
  		splash = new Splash(); 
	   	// a umstme pltno na aktuln displej 
		 display.setCurrent(splash); 

	splash.SetProgress(0);
		 

	
	loadOptions();	
	
	big_he = Options.options[12];

	try {
		TextGraphics.readImages();				//static
	} catch (IOException e) {}
	

	splash.SetProgress(20);
		
		mdd = new MDD();

		mdd.data_available[0] = mdd.TestIndexFrom();		
		mdd.data_available[1] = mdd.TestIndexTo();
		
		try{
			mdd.OpenIndexes();
		} catch (IOException e) {}

		
		
	splash.SetProgress(40);
		
		try{
			mdd.OpenSortTables();
		} catch (IOException e) {}

		
	splash.SetProgress(60);

	
	
		//create new instance of Search class
		search = new Search(); 	//not display yet
		Search.loadHebrewTable();


	splash.SetProgress(80);		
		
		dict_cz = new DictCZ();
		
	splash.SetProgress(100);		


	
		dict_he = new DictHE();


		
		//inic variables according what should be remembered:
		if(Options.options[0] == 1){				//remember direction
			MDD.direction = Options.options[2]; 
		}
		else{
			MDD.direction = 0;						//default HE->CZ
		}
		
		
//if we have HE->CZ direction, then set it:
		if(MDD.direction == 0 && mdd.data_available[0] == 1){
		
			display.setCurrent(dict_he);		//set HE-CZ direction active
	
			mdd.data_file = 1;			//from first file
			mdd.data_offset = 0;		//and from start
	
			//Before first reading(ONLY!) we must find sync and synchronize it
			try{
				mdd.FindNextSync(MDD.direction, mdd.data_file, mdd.data_offset);
	    	} catch (IOException e) {}	
			
	    	dict_he.repaint();
		}
		else{
			
			//try CZ->HE IF AVAILABLE!
			if(mdd.data_available[1] == 1){

				display.setCurrent(dict_cz);		//set HE-CZ direction active

				MDD.direction = 1;			//inic direction 0: from he to CZ
				mdd.data_file = 1;			//from first file
				mdd.data_offset = 0;		//and from start
		
				//Before first reading(ONLY!) we must find sync and synchronize it
				try{
					mdd.FindNextSync(mdd.direction, mdd.data_file, mdd.data_offset);
		    	} catch (IOException e) {}	
				
		    	dict_cz.repaint();
			}
		}
		

		
		
		
		
    }
    
    
    public void startApp() {    }    
    public void pauseApp() {    }   

    public void destroyApp(boolean unconditional) throws MIDletStateChangeException { 

    	//if we need save direction, we will save NOW 
    	if(Options.options[0] == 1 ){
    		Options.options[2] = MDD.direction;			//last direction
    		
    		saveOptions();
    	}
    	
    	/// aplikace informuje manaer aplikac aby ji ukonil a uvolnil zdroje kter obsadila 
    	notifyDestroyed(); 
    	return;
    }        

//----------------------------------------------------------------

//zobrazi vypis HE slovicek
public static void ShowHebrewDictCanvas(){
	//a umstme pltno na aktuln displej 
	display.setCurrent(dict_he);
	dict_he.repaint();

	return;
}

//----------------------------------------------------------------//
//zobrazi vypis CZ slovicek
public static void ShowDictCZCanvas(){
	//a umstme pltno na aktuln displej 
	display.setCurrent(dict_cz); 
	dict_cz.repaint();

	return;
}

//----------------------------------------------------------------//

   

//----------------------------------------------------------------//

static public void	ShowSearchHebrew()
{
int	f;


//nulujeme hledany he string
for(f=0; f < KEY_SIZE_MAX; f++)
	key_HE[f]=0;

//jeho delka je 0
key_size_HE=0;


// a umstme cSearchHE na aktuln displej 
display.setCurrent(search); 

return;
}

//----------------------------------------------------------------//


//turn dictionary to opposite
static public void OppositeDirection()
{
int		f, g;
String	s;


    //zajistime, aby po otoceni zacinal vypis v miste,
    //kde jsme byli v opacnem slovniku

    if(MDD.direction == 0){     //HE->CZ state

    	//EXISTS DATA FOR OPPOSITE DIRECTION?
    	if(mdd.data_available[1] == 0){
    		return;							//NO TURN OF DICT!
    	}

		//now we will get first record on the page and seek for word
		try{
			mdd.ReadRecord(MDD.direction, mdd.data_file_first, mdd.data_offset_first, 0);
		} catch (IOException e) {}
		//use TO part as keyword after change direction
		//only get max key_length bytes
		
		g = 0;
		for(f=0; f<MDD.key_length; f++){
        	if(mdd.data_to[f] == 0)
        		break;
        	
        	mDavar.key_CZ[f]=mdd.data_to[f];
        	//correction to signed byte value:
        	if(mDavar.key_CZ[f]<0)
        		mDavar.key_CZ[f] += 256;
        	
        	g++;
        }
			
        //key size
		mDavar.key_size_CZ = g;
		//System.out.println(s + '\n');
		
    	MDD.direction = 1;		//now CZ->HE

		Search.SearchCZ();
		mDavar.ShowDictCZCanvas();
	
		
    }

    else{                   	//CZ->HE

    	//EXISTS DATA FOR OPPOSITE DIRECTION?
    	if(mdd.data_available[0] == 0){
    		return;							//NO TURN OF DICT!
    	}

    	
		//now we will get first record on the page and seek for word
		try{
			mdd.ReadRecord(mdd.direction, mdd.data_file_first, mdd.data_offset_first, 0);
		} catch (IOException e) {}
		//use TO part as keyword after change direction

		g=0;
		//create HE string in opposite order
		for(f = mdd.data_to_size-1; f>=0; f--){
//        	if(mdd.data_to[f] == 0)
//        		break;

        	mDavar.key_HE[g]=mdd.data_to[f];
        	g++;
        	if(g>MDD.key_length){
        		g--;
        		break;
        	}
		}

			
        //key size
		mDavar.key_size_HE=g;
			
    	MDD.direction = 0;		//now HE->CZ

		Search.SearchHebrew();
		mDavar.ShowHebrewDictCanvas();
    	
    }


return;
}

//-------------------------------------------------------------------

public static void ShowOptions(){
	
	options = new Options();
	display.setCurrent(options);

	return;

}

//-------------------------------------------------------------------
//method which will fill options[] variables - called on the start
public static void loadOptions(){
	
	options = new Options();
	options.loadOptions();
	//System.out.println(Options.options[8]);
	
	return;

}
//-------------------------------------------------------------------

//method which save options -  options[] variables - called on the end
public static void saveOptions(){
	
	options = new Options();
	options.saveOptions();
	
	return;

}
//-------------------------------------------------------------------

}
